// Code generated by moq; DO NOT EDIT.
// github.com/matryer/moq

package fakes

import (
	context "context"
	sync "sync"
	time "time"

	controller "github.com/rancher/norman/controller"
	objectclient "github.com/rancher/norman/objectclient"
	v3 "github.com/rancher/types/apis/management.cattle.io/v3"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

var (
	lockProjectMonitorGraphListerMockGet  sync.RWMutex
	lockProjectMonitorGraphListerMockList sync.RWMutex
)

// Ensure, that ProjectMonitorGraphListerMock does implement ProjectMonitorGraphLister.
// If this is not the case, regenerate this file with moq.
var _ v3.ProjectMonitorGraphLister = &ProjectMonitorGraphListerMock{}

// ProjectMonitorGraphListerMock is a mock implementation of ProjectMonitorGraphLister.
//
//     func TestSomethingThatUsesProjectMonitorGraphLister(t *testing.T) {
//
//         // make and configure a mocked ProjectMonitorGraphLister
//         mockedProjectMonitorGraphLister := &ProjectMonitorGraphListerMock{
//             GetFunc: func(namespace string, name string) (*v3.ProjectMonitorGraph, error) {
// 	               panic("mock out the Get method")
//             },
//             ListFunc: func(namespace string, selector labels.Selector) ([]*v3.ProjectMonitorGraph, error) {
// 	               panic("mock out the List method")
//             },
//         }
//
//         // use mockedProjectMonitorGraphLister in code that requires ProjectMonitorGraphLister
//         // and then make assertions.
//
//     }
type ProjectMonitorGraphListerMock struct {
	// GetFunc mocks the Get method.
	GetFunc func(namespace string, name string) (*v3.ProjectMonitorGraph, error)

	// ListFunc mocks the List method.
	ListFunc func(namespace string, selector labels.Selector) ([]*v3.ProjectMonitorGraph, error)

	// calls tracks calls to the methods.
	calls struct {
		// Get holds details about calls to the Get method.
		Get []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
		}
		// List holds details about calls to the List method.
		List []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Selector is the selector argument value.
			Selector labels.Selector
		}
	}
}

// Get calls GetFunc.
func (mock *ProjectMonitorGraphListerMock) Get(namespace string, name string) (*v3.ProjectMonitorGraph, error) {
	if mock.GetFunc == nil {
		panic("ProjectMonitorGraphListerMock.GetFunc: method is nil but ProjectMonitorGraphLister.Get was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
	}{
		Namespace: namespace,
		Name:      name,
	}
	lockProjectMonitorGraphListerMockGet.Lock()
	mock.calls.Get = append(mock.calls.Get, callInfo)
	lockProjectMonitorGraphListerMockGet.Unlock()
	return mock.GetFunc(namespace, name)
}

// GetCalls gets all the calls that were made to Get.
// Check the length with:
//     len(mockedProjectMonitorGraphLister.GetCalls())
func (mock *ProjectMonitorGraphListerMock) GetCalls() []struct {
	Namespace string
	Name      string
} {
	var calls []struct {
		Namespace string
		Name      string
	}
	lockProjectMonitorGraphListerMockGet.RLock()
	calls = mock.calls.Get
	lockProjectMonitorGraphListerMockGet.RUnlock()
	return calls
}

// List calls ListFunc.
func (mock *ProjectMonitorGraphListerMock) List(namespace string, selector labels.Selector) ([]*v3.ProjectMonitorGraph, error) {
	if mock.ListFunc == nil {
		panic("ProjectMonitorGraphListerMock.ListFunc: method is nil but ProjectMonitorGraphLister.List was just called")
	}
	callInfo := struct {
		Namespace string
		Selector  labels.Selector
	}{
		Namespace: namespace,
		Selector:  selector,
	}
	lockProjectMonitorGraphListerMockList.Lock()
	mock.calls.List = append(mock.calls.List, callInfo)
	lockProjectMonitorGraphListerMockList.Unlock()
	return mock.ListFunc(namespace, selector)
}

// ListCalls gets all the calls that were made to List.
// Check the length with:
//     len(mockedProjectMonitorGraphLister.ListCalls())
func (mock *ProjectMonitorGraphListerMock) ListCalls() []struct {
	Namespace string
	Selector  labels.Selector
} {
	var calls []struct {
		Namespace string
		Selector  labels.Selector
	}
	lockProjectMonitorGraphListerMockList.RLock()
	calls = mock.calls.List
	lockProjectMonitorGraphListerMockList.RUnlock()
	return calls
}

var (
	lockProjectMonitorGraphControllerMockAddClusterScopedFeatureHandler sync.RWMutex
	lockProjectMonitorGraphControllerMockAddClusterScopedHandler        sync.RWMutex
	lockProjectMonitorGraphControllerMockAddFeatureHandler              sync.RWMutex
	lockProjectMonitorGraphControllerMockAddHandler                     sync.RWMutex
	lockProjectMonitorGraphControllerMockEnqueue                        sync.RWMutex
	lockProjectMonitorGraphControllerMockEnqueueAfter                   sync.RWMutex
	lockProjectMonitorGraphControllerMockGeneric                        sync.RWMutex
	lockProjectMonitorGraphControllerMockInformer                       sync.RWMutex
	lockProjectMonitorGraphControllerMockLister                         sync.RWMutex
)

// Ensure, that ProjectMonitorGraphControllerMock does implement ProjectMonitorGraphController.
// If this is not the case, regenerate this file with moq.
var _ v3.ProjectMonitorGraphController = &ProjectMonitorGraphControllerMock{}

// ProjectMonitorGraphControllerMock is a mock implementation of ProjectMonitorGraphController.
//
//     func TestSomethingThatUsesProjectMonitorGraphController(t *testing.T) {
//
//         // make and configure a mocked ProjectMonitorGraphController
//         mockedProjectMonitorGraphController := &ProjectMonitorGraphControllerMock{
//             AddClusterScopedFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, clusterName string, handler v3.ProjectMonitorGraphHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedFeatureHandler method")
//             },
//             AddClusterScopedHandlerFunc: func(ctx context.Context, name string, clusterName string, handler v3.ProjectMonitorGraphHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedHandler method")
//             },
//             AddFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, sync v3.ProjectMonitorGraphHandlerFunc)  {
// 	               panic("mock out the AddFeatureHandler method")
//             },
//             AddHandlerFunc: func(ctx context.Context, name string, handler v3.ProjectMonitorGraphHandlerFunc)  {
// 	               panic("mock out the AddHandler method")
//             },
//             EnqueueFunc: func(namespace string, name string)  {
// 	               panic("mock out the Enqueue method")
//             },
//             EnqueueAfterFunc: func(namespace string, name string, after time.Duration)  {
// 	               panic("mock out the EnqueueAfter method")
//             },
//             GenericFunc: func() controller.GenericController {
// 	               panic("mock out the Generic method")
//             },
//             InformerFunc: func() cache.SharedIndexInformer {
// 	               panic("mock out the Informer method")
//             },
//             ListerFunc: func() v3.ProjectMonitorGraphLister {
// 	               panic("mock out the Lister method")
//             },
//         }
//
//         // use mockedProjectMonitorGraphController in code that requires ProjectMonitorGraphController
//         // and then make assertions.
//
//     }
type ProjectMonitorGraphControllerMock struct {
	// AddClusterScopedFeatureHandlerFunc mocks the AddClusterScopedFeatureHandler method.
	AddClusterScopedFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, clusterName string, handler v3.ProjectMonitorGraphHandlerFunc)

	// AddClusterScopedHandlerFunc mocks the AddClusterScopedHandler method.
	AddClusterScopedHandlerFunc func(ctx context.Context, name string, clusterName string, handler v3.ProjectMonitorGraphHandlerFunc)

	// AddFeatureHandlerFunc mocks the AddFeatureHandler method.
	AddFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, sync v3.ProjectMonitorGraphHandlerFunc)

	// AddHandlerFunc mocks the AddHandler method.
	AddHandlerFunc func(ctx context.Context, name string, handler v3.ProjectMonitorGraphHandlerFunc)

	// EnqueueFunc mocks the Enqueue method.
	EnqueueFunc func(namespace string, name string)

	// EnqueueAfterFunc mocks the EnqueueAfter method.
	EnqueueAfterFunc func(namespace string, name string, after time.Duration)

	// GenericFunc mocks the Generic method.
	GenericFunc func() controller.GenericController

	// InformerFunc mocks the Informer method.
	InformerFunc func() cache.SharedIndexInformer

	// ListerFunc mocks the Lister method.
	ListerFunc func() v3.ProjectMonitorGraphLister

	// calls tracks calls to the methods.
	calls struct {
		// AddClusterScopedFeatureHandler holds details about calls to the AddClusterScopedFeatureHandler method.
		AddClusterScopedFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Handler is the handler argument value.
			Handler v3.ProjectMonitorGraphHandlerFunc
		}
		// AddClusterScopedHandler holds details about calls to the AddClusterScopedHandler method.
		AddClusterScopedHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Handler is the handler argument value.
			Handler v3.ProjectMonitorGraphHandlerFunc
		}
		// AddFeatureHandler holds details about calls to the AddFeatureHandler method.
		AddFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// Sync is the sync argument value.
			Sync v3.ProjectMonitorGraphHandlerFunc
		}
		// AddHandler holds details about calls to the AddHandler method.
		AddHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// Handler is the handler argument value.
			Handler v3.ProjectMonitorGraphHandlerFunc
		}
		// Enqueue holds details about calls to the Enqueue method.
		Enqueue []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
		}
		// EnqueueAfter holds details about calls to the EnqueueAfter method.
		EnqueueAfter []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
			// After is the after argument value.
			After time.Duration
		}
		// Generic holds details about calls to the Generic method.
		Generic []struct {
		}
		// Informer holds details about calls to the Informer method.
		Informer []struct {
		}
		// Lister holds details about calls to the Lister method.
		Lister []struct {
		}
	}
}

// AddClusterScopedFeatureHandler calls AddClusterScopedFeatureHandlerFunc.
func (mock *ProjectMonitorGraphControllerMock) AddClusterScopedFeatureHandler(ctx context.Context, enabled func() bool, name string, clusterName string, handler v3.ProjectMonitorGraphHandlerFunc) {
	if mock.AddClusterScopedFeatureHandlerFunc == nil {
		panic("ProjectMonitorGraphControllerMock.AddClusterScopedFeatureHandlerFunc: method is nil but ProjectMonitorGraphController.AddClusterScopedFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Handler     v3.ProjectMonitorGraphHandlerFunc
	}{
		Ctx:         ctx,
		Enabled:     enabled,
		Name:        name,
		ClusterName: clusterName,
		Handler:     handler,
	}
	lockProjectMonitorGraphControllerMockAddClusterScopedFeatureHandler.Lock()
	mock.calls.AddClusterScopedFeatureHandler = append(mock.calls.AddClusterScopedFeatureHandler, callInfo)
	lockProjectMonitorGraphControllerMockAddClusterScopedFeatureHandler.Unlock()
	mock.AddClusterScopedFeatureHandlerFunc(ctx, enabled, name, clusterName, handler)
}

// AddClusterScopedFeatureHandlerCalls gets all the calls that were made to AddClusterScopedFeatureHandler.
// Check the length with:
//     len(mockedProjectMonitorGraphController.AddClusterScopedFeatureHandlerCalls())
func (mock *ProjectMonitorGraphControllerMock) AddClusterScopedFeatureHandlerCalls() []struct {
	Ctx         context.Context
	Enabled     func() bool
	Name        string
	ClusterName string
	Handler     v3.ProjectMonitorGraphHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Handler     v3.ProjectMonitorGraphHandlerFunc
	}
	lockProjectMonitorGraphControllerMockAddClusterScopedFeatureHandler.RLock()
	calls = mock.calls.AddClusterScopedFeatureHandler
	lockProjectMonitorGraphControllerMockAddClusterScopedFeatureHandler.RUnlock()
	return calls
}

// AddClusterScopedHandler calls AddClusterScopedHandlerFunc.
func (mock *ProjectMonitorGraphControllerMock) AddClusterScopedHandler(ctx context.Context, name string, clusterName string, handler v3.ProjectMonitorGraphHandlerFunc) {
	if mock.AddClusterScopedHandlerFunc == nil {
		panic("ProjectMonitorGraphControllerMock.AddClusterScopedHandlerFunc: method is nil but ProjectMonitorGraphController.AddClusterScopedHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Handler     v3.ProjectMonitorGraphHandlerFunc
	}{
		Ctx:         ctx,
		Name:        name,
		ClusterName: clusterName,
		Handler:     handler,
	}
	lockProjectMonitorGraphControllerMockAddClusterScopedHandler.Lock()
	mock.calls.AddClusterScopedHandler = append(mock.calls.AddClusterScopedHandler, callInfo)
	lockProjectMonitorGraphControllerMockAddClusterScopedHandler.Unlock()
	mock.AddClusterScopedHandlerFunc(ctx, name, clusterName, handler)
}

// AddClusterScopedHandlerCalls gets all the calls that were made to AddClusterScopedHandler.
// Check the length with:
//     len(mockedProjectMonitorGraphController.AddClusterScopedHandlerCalls())
func (mock *ProjectMonitorGraphControllerMock) AddClusterScopedHandlerCalls() []struct {
	Ctx         context.Context
	Name        string
	ClusterName string
	Handler     v3.ProjectMonitorGraphHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Handler     v3.ProjectMonitorGraphHandlerFunc
	}
	lockProjectMonitorGraphControllerMockAddClusterScopedHandler.RLock()
	calls = mock.calls.AddClusterScopedHandler
	lockProjectMonitorGraphControllerMockAddClusterScopedHandler.RUnlock()
	return calls
}

// AddFeatureHandler calls AddFeatureHandlerFunc.
func (mock *ProjectMonitorGraphControllerMock) AddFeatureHandler(ctx context.Context, enabled func() bool, name string, sync v3.ProjectMonitorGraphHandlerFunc) {
	if mock.AddFeatureHandlerFunc == nil {
		panic("ProjectMonitorGraphControllerMock.AddFeatureHandlerFunc: method is nil but ProjectMonitorGraphController.AddFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v3.ProjectMonitorGraphHandlerFunc
	}{
		Ctx:     ctx,
		Enabled: enabled,
		Name:    name,
		Sync:    sync,
	}
	lockProjectMonitorGraphControllerMockAddFeatureHandler.Lock()
	mock.calls.AddFeatureHandler = append(mock.calls.AddFeatureHandler, callInfo)
	lockProjectMonitorGraphControllerMockAddFeatureHandler.Unlock()
	mock.AddFeatureHandlerFunc(ctx, enabled, name, sync)
}

// AddFeatureHandlerCalls gets all the calls that were made to AddFeatureHandler.
// Check the length with:
//     len(mockedProjectMonitorGraphController.AddFeatureHandlerCalls())
func (mock *ProjectMonitorGraphControllerMock) AddFeatureHandlerCalls() []struct {
	Ctx     context.Context
	Enabled func() bool
	Name    string
	Sync    v3.ProjectMonitorGraphHandlerFunc
} {
	var calls []struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v3.ProjectMonitorGraphHandlerFunc
	}
	lockProjectMonitorGraphControllerMockAddFeatureHandler.RLock()
	calls = mock.calls.AddFeatureHandler
	lockProjectMonitorGraphControllerMockAddFeatureHandler.RUnlock()
	return calls
}

// AddHandler calls AddHandlerFunc.
func (mock *ProjectMonitorGraphControllerMock) AddHandler(ctx context.Context, name string, handler v3.ProjectMonitorGraphHandlerFunc) {
	if mock.AddHandlerFunc == nil {
		panic("ProjectMonitorGraphControllerMock.AddHandlerFunc: method is nil but ProjectMonitorGraphController.AddHandler was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Name    string
		Handler v3.ProjectMonitorGraphHandlerFunc
	}{
		Ctx:     ctx,
		Name:    name,
		Handler: handler,
	}
	lockProjectMonitorGraphControllerMockAddHandler.Lock()
	mock.calls.AddHandler = append(mock.calls.AddHandler, callInfo)
	lockProjectMonitorGraphControllerMockAddHandler.Unlock()
	mock.AddHandlerFunc(ctx, name, handler)
}

// AddHandlerCalls gets all the calls that were made to AddHandler.
// Check the length with:
//     len(mockedProjectMonitorGraphController.AddHandlerCalls())
func (mock *ProjectMonitorGraphControllerMock) AddHandlerCalls() []struct {
	Ctx     context.Context
	Name    string
	Handler v3.ProjectMonitorGraphHandlerFunc
} {
	var calls []struct {
		Ctx     context.Context
		Name    string
		Handler v3.ProjectMonitorGraphHandlerFunc
	}
	lockProjectMonitorGraphControllerMockAddHandler.RLock()
	calls = mock.calls.AddHandler
	lockProjectMonitorGraphControllerMockAddHandler.RUnlock()
	return calls
}

// Enqueue calls EnqueueFunc.
func (mock *ProjectMonitorGraphControllerMock) Enqueue(namespace string, name string) {
	if mock.EnqueueFunc == nil {
		panic("ProjectMonitorGraphControllerMock.EnqueueFunc: method is nil but ProjectMonitorGraphController.Enqueue was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
	}{
		Namespace: namespace,
		Name:      name,
	}
	lockProjectMonitorGraphControllerMockEnqueue.Lock()
	mock.calls.Enqueue = append(mock.calls.Enqueue, callInfo)
	lockProjectMonitorGraphControllerMockEnqueue.Unlock()
	mock.EnqueueFunc(namespace, name)
}

// EnqueueCalls gets all the calls that were made to Enqueue.
// Check the length with:
//     len(mockedProjectMonitorGraphController.EnqueueCalls())
func (mock *ProjectMonitorGraphControllerMock) EnqueueCalls() []struct {
	Namespace string
	Name      string
} {
	var calls []struct {
		Namespace string
		Name      string
	}
	lockProjectMonitorGraphControllerMockEnqueue.RLock()
	calls = mock.calls.Enqueue
	lockProjectMonitorGraphControllerMockEnqueue.RUnlock()
	return calls
}

// EnqueueAfter calls EnqueueAfterFunc.
func (mock *ProjectMonitorGraphControllerMock) EnqueueAfter(namespace string, name string, after time.Duration) {
	if mock.EnqueueAfterFunc == nil {
		panic("ProjectMonitorGraphControllerMock.EnqueueAfterFunc: method is nil but ProjectMonitorGraphController.EnqueueAfter was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
		After     time.Duration
	}{
		Namespace: namespace,
		Name:      name,
		After:     after,
	}
	lockProjectMonitorGraphControllerMockEnqueueAfter.Lock()
	mock.calls.EnqueueAfter = append(mock.calls.EnqueueAfter, callInfo)
	lockProjectMonitorGraphControllerMockEnqueueAfter.Unlock()
	mock.EnqueueAfterFunc(namespace, name, after)
}

// EnqueueAfterCalls gets all the calls that were made to EnqueueAfter.
// Check the length with:
//     len(mockedProjectMonitorGraphController.EnqueueAfterCalls())
func (mock *ProjectMonitorGraphControllerMock) EnqueueAfterCalls() []struct {
	Namespace string
	Name      string
	After     time.Duration
} {
	var calls []struct {
		Namespace string
		Name      string
		After     time.Duration
	}
	lockProjectMonitorGraphControllerMockEnqueueAfter.RLock()
	calls = mock.calls.EnqueueAfter
	lockProjectMonitorGraphControllerMockEnqueueAfter.RUnlock()
	return calls
}

// Generic calls GenericFunc.
func (mock *ProjectMonitorGraphControllerMock) Generic() controller.GenericController {
	if mock.GenericFunc == nil {
		panic("ProjectMonitorGraphControllerMock.GenericFunc: method is nil but ProjectMonitorGraphController.Generic was just called")
	}
	callInfo := struct {
	}{}
	lockProjectMonitorGraphControllerMockGeneric.Lock()
	mock.calls.Generic = append(mock.calls.Generic, callInfo)
	lockProjectMonitorGraphControllerMockGeneric.Unlock()
	return mock.GenericFunc()
}

// GenericCalls gets all the calls that were made to Generic.
// Check the length with:
//     len(mockedProjectMonitorGraphController.GenericCalls())
func (mock *ProjectMonitorGraphControllerMock) GenericCalls() []struct {
} {
	var calls []struct {
	}
	lockProjectMonitorGraphControllerMockGeneric.RLock()
	calls = mock.calls.Generic
	lockProjectMonitorGraphControllerMockGeneric.RUnlock()
	return calls
}

// Informer calls InformerFunc.
func (mock *ProjectMonitorGraphControllerMock) Informer() cache.SharedIndexInformer {
	if mock.InformerFunc == nil {
		panic("ProjectMonitorGraphControllerMock.InformerFunc: method is nil but ProjectMonitorGraphController.Informer was just called")
	}
	callInfo := struct {
	}{}
	lockProjectMonitorGraphControllerMockInformer.Lock()
	mock.calls.Informer = append(mock.calls.Informer, callInfo)
	lockProjectMonitorGraphControllerMockInformer.Unlock()
	return mock.InformerFunc()
}

// InformerCalls gets all the calls that were made to Informer.
// Check the length with:
//     len(mockedProjectMonitorGraphController.InformerCalls())
func (mock *ProjectMonitorGraphControllerMock) InformerCalls() []struct {
} {
	var calls []struct {
	}
	lockProjectMonitorGraphControllerMockInformer.RLock()
	calls = mock.calls.Informer
	lockProjectMonitorGraphControllerMockInformer.RUnlock()
	return calls
}

// Lister calls ListerFunc.
func (mock *ProjectMonitorGraphControllerMock) Lister() v3.ProjectMonitorGraphLister {
	if mock.ListerFunc == nil {
		panic("ProjectMonitorGraphControllerMock.ListerFunc: method is nil but ProjectMonitorGraphController.Lister was just called")
	}
	callInfo := struct {
	}{}
	lockProjectMonitorGraphControllerMockLister.Lock()
	mock.calls.Lister = append(mock.calls.Lister, callInfo)
	lockProjectMonitorGraphControllerMockLister.Unlock()
	return mock.ListerFunc()
}

// ListerCalls gets all the calls that were made to Lister.
// Check the length with:
//     len(mockedProjectMonitorGraphController.ListerCalls())
func (mock *ProjectMonitorGraphControllerMock) ListerCalls() []struct {
} {
	var calls []struct {
	}
	lockProjectMonitorGraphControllerMockLister.RLock()
	calls = mock.calls.Lister
	lockProjectMonitorGraphControllerMockLister.RUnlock()
	return calls
}

var (
	lockProjectMonitorGraphInterfaceMockAddClusterScopedFeatureHandler   sync.RWMutex
	lockProjectMonitorGraphInterfaceMockAddClusterScopedFeatureLifecycle sync.RWMutex
	lockProjectMonitorGraphInterfaceMockAddClusterScopedHandler          sync.RWMutex
	lockProjectMonitorGraphInterfaceMockAddClusterScopedLifecycle        sync.RWMutex
	lockProjectMonitorGraphInterfaceMockAddFeatureHandler                sync.RWMutex
	lockProjectMonitorGraphInterfaceMockAddFeatureLifecycle              sync.RWMutex
	lockProjectMonitorGraphInterfaceMockAddHandler                       sync.RWMutex
	lockProjectMonitorGraphInterfaceMockAddLifecycle                     sync.RWMutex
	lockProjectMonitorGraphInterfaceMockController                       sync.RWMutex
	lockProjectMonitorGraphInterfaceMockCreate                           sync.RWMutex
	lockProjectMonitorGraphInterfaceMockDelete                           sync.RWMutex
	lockProjectMonitorGraphInterfaceMockDeleteCollection                 sync.RWMutex
	lockProjectMonitorGraphInterfaceMockDeleteNamespaced                 sync.RWMutex
	lockProjectMonitorGraphInterfaceMockGet                              sync.RWMutex
	lockProjectMonitorGraphInterfaceMockGetNamespaced                    sync.RWMutex
	lockProjectMonitorGraphInterfaceMockList                             sync.RWMutex
	lockProjectMonitorGraphInterfaceMockListNamespaced                   sync.RWMutex
	lockProjectMonitorGraphInterfaceMockObjectClient                     sync.RWMutex
	lockProjectMonitorGraphInterfaceMockUpdate                           sync.RWMutex
	lockProjectMonitorGraphInterfaceMockWatch                            sync.RWMutex
)

// Ensure, that ProjectMonitorGraphInterfaceMock does implement ProjectMonitorGraphInterface.
// If this is not the case, regenerate this file with moq.
var _ v3.ProjectMonitorGraphInterface = &ProjectMonitorGraphInterfaceMock{}

// ProjectMonitorGraphInterfaceMock is a mock implementation of ProjectMonitorGraphInterface.
//
//     func TestSomethingThatUsesProjectMonitorGraphInterface(t *testing.T) {
//
//         // make and configure a mocked ProjectMonitorGraphInterface
//         mockedProjectMonitorGraphInterface := &ProjectMonitorGraphInterfaceMock{
//             AddClusterScopedFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, clusterName string, sync v3.ProjectMonitorGraphHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedFeatureHandler method")
//             },
//             AddClusterScopedFeatureLifecycleFunc: func(ctx context.Context, enabled func() bool, name string, clusterName string, lifecycle v3.ProjectMonitorGraphLifecycle)  {
// 	               panic("mock out the AddClusterScopedFeatureLifecycle method")
//             },
//             AddClusterScopedHandlerFunc: func(ctx context.Context, name string, clusterName string, sync v3.ProjectMonitorGraphHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedHandler method")
//             },
//             AddClusterScopedLifecycleFunc: func(ctx context.Context, name string, clusterName string, lifecycle v3.ProjectMonitorGraphLifecycle)  {
// 	               panic("mock out the AddClusterScopedLifecycle method")
//             },
//             AddFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, sync v3.ProjectMonitorGraphHandlerFunc)  {
// 	               panic("mock out the AddFeatureHandler method")
//             },
//             AddFeatureLifecycleFunc: func(ctx context.Context, enabled func() bool, name string, lifecycle v3.ProjectMonitorGraphLifecycle)  {
// 	               panic("mock out the AddFeatureLifecycle method")
//             },
//             AddHandlerFunc: func(ctx context.Context, name string, sync v3.ProjectMonitorGraphHandlerFunc)  {
// 	               panic("mock out the AddHandler method")
//             },
//             AddLifecycleFunc: func(ctx context.Context, name string, lifecycle v3.ProjectMonitorGraphLifecycle)  {
// 	               panic("mock out the AddLifecycle method")
//             },
//             ControllerFunc: func() v3.ProjectMonitorGraphController {
// 	               panic("mock out the Controller method")
//             },
//             CreateFunc: func(in1 *v3.ProjectMonitorGraph) (*v3.ProjectMonitorGraph, error) {
// 	               panic("mock out the Create method")
//             },
//             DeleteFunc: func(name string, options *v1.DeleteOptions) error {
// 	               panic("mock out the Delete method")
//             },
//             DeleteCollectionFunc: func(deleteOpts *v1.DeleteOptions, listOpts v1.ListOptions) error {
// 	               panic("mock out the DeleteCollection method")
//             },
//             DeleteNamespacedFunc: func(namespace string, name string, options *v1.DeleteOptions) error {
// 	               panic("mock out the DeleteNamespaced method")
//             },
//             GetFunc: func(name string, opts v1.GetOptions) (*v3.ProjectMonitorGraph, error) {
// 	               panic("mock out the Get method")
//             },
//             GetNamespacedFunc: func(namespace string, name string, opts v1.GetOptions) (*v3.ProjectMonitorGraph, error) {
// 	               panic("mock out the GetNamespaced method")
//             },
//             ListFunc: func(opts v1.ListOptions) (*v3.ProjectMonitorGraphList, error) {
// 	               panic("mock out the List method")
//             },
//             ListNamespacedFunc: func(namespace string, opts v1.ListOptions) (*v3.ProjectMonitorGraphList, error) {
// 	               panic("mock out the ListNamespaced method")
//             },
//             ObjectClientFunc: func() *objectclient.ObjectClient {
// 	               panic("mock out the ObjectClient method")
//             },
//             UpdateFunc: func(in1 *v3.ProjectMonitorGraph) (*v3.ProjectMonitorGraph, error) {
// 	               panic("mock out the Update method")
//             },
//             WatchFunc: func(opts v1.ListOptions) (watch.Interface, error) {
// 	               panic("mock out the Watch method")
//             },
//         }
//
//         // use mockedProjectMonitorGraphInterface in code that requires ProjectMonitorGraphInterface
//         // and then make assertions.
//
//     }
type ProjectMonitorGraphInterfaceMock struct {
	// AddClusterScopedFeatureHandlerFunc mocks the AddClusterScopedFeatureHandler method.
	AddClusterScopedFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, clusterName string, sync v3.ProjectMonitorGraphHandlerFunc)

	// AddClusterScopedFeatureLifecycleFunc mocks the AddClusterScopedFeatureLifecycle method.
	AddClusterScopedFeatureLifecycleFunc func(ctx context.Context, enabled func() bool, name string, clusterName string, lifecycle v3.ProjectMonitorGraphLifecycle)

	// AddClusterScopedHandlerFunc mocks the AddClusterScopedHandler method.
	AddClusterScopedHandlerFunc func(ctx context.Context, name string, clusterName string, sync v3.ProjectMonitorGraphHandlerFunc)

	// AddClusterScopedLifecycleFunc mocks the AddClusterScopedLifecycle method.
	AddClusterScopedLifecycleFunc func(ctx context.Context, name string, clusterName string, lifecycle v3.ProjectMonitorGraphLifecycle)

	// AddFeatureHandlerFunc mocks the AddFeatureHandler method.
	AddFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, sync v3.ProjectMonitorGraphHandlerFunc)

	// AddFeatureLifecycleFunc mocks the AddFeatureLifecycle method.
	AddFeatureLifecycleFunc func(ctx context.Context, enabled func() bool, name string, lifecycle v3.ProjectMonitorGraphLifecycle)

	// AddHandlerFunc mocks the AddHandler method.
	AddHandlerFunc func(ctx context.Context, name string, sync v3.ProjectMonitorGraphHandlerFunc)

	// AddLifecycleFunc mocks the AddLifecycle method.
	AddLifecycleFunc func(ctx context.Context, name string, lifecycle v3.ProjectMonitorGraphLifecycle)

	// ControllerFunc mocks the Controller method.
	ControllerFunc func() v3.ProjectMonitorGraphController

	// CreateFunc mocks the Create method.
	CreateFunc func(in1 *v3.ProjectMonitorGraph) (*v3.ProjectMonitorGraph, error)

	// DeleteFunc mocks the Delete method.
	DeleteFunc func(name string, options *v1.DeleteOptions) error

	// DeleteCollectionFunc mocks the DeleteCollection method.
	DeleteCollectionFunc func(deleteOpts *v1.DeleteOptions, listOpts v1.ListOptions) error

	// DeleteNamespacedFunc mocks the DeleteNamespaced method.
	DeleteNamespacedFunc func(namespace string, name string, options *v1.DeleteOptions) error

	// GetFunc mocks the Get method.
	GetFunc func(name string, opts v1.GetOptions) (*v3.ProjectMonitorGraph, error)

	// GetNamespacedFunc mocks the GetNamespaced method.
	GetNamespacedFunc func(namespace string, name string, opts v1.GetOptions) (*v3.ProjectMonitorGraph, error)

	// ListFunc mocks the List method.
	ListFunc func(opts v1.ListOptions) (*v3.ProjectMonitorGraphList, error)

	// ListNamespacedFunc mocks the ListNamespaced method.
	ListNamespacedFunc func(namespace string, opts v1.ListOptions) (*v3.ProjectMonitorGraphList, error)

	// ObjectClientFunc mocks the ObjectClient method.
	ObjectClientFunc func() *objectclient.ObjectClient

	// UpdateFunc mocks the Update method.
	UpdateFunc func(in1 *v3.ProjectMonitorGraph) (*v3.ProjectMonitorGraph, error)

	// WatchFunc mocks the Watch method.
	WatchFunc func(opts v1.ListOptions) (watch.Interface, error)

	// calls tracks calls to the methods.
	calls struct {
		// AddClusterScopedFeatureHandler holds details about calls to the AddClusterScopedFeatureHandler method.
		AddClusterScopedFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Sync is the sync argument value.
			Sync v3.ProjectMonitorGraphHandlerFunc
		}
		// AddClusterScopedFeatureLifecycle holds details about calls to the AddClusterScopedFeatureLifecycle method.
		AddClusterScopedFeatureLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v3.ProjectMonitorGraphLifecycle
		}
		// AddClusterScopedHandler holds details about calls to the AddClusterScopedHandler method.
		AddClusterScopedHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Sync is the sync argument value.
			Sync v3.ProjectMonitorGraphHandlerFunc
		}
		// AddClusterScopedLifecycle holds details about calls to the AddClusterScopedLifecycle method.
		AddClusterScopedLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v3.ProjectMonitorGraphLifecycle
		}
		// AddFeatureHandler holds details about calls to the AddFeatureHandler method.
		AddFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// Sync is the sync argument value.
			Sync v3.ProjectMonitorGraphHandlerFunc
		}
		// AddFeatureLifecycle holds details about calls to the AddFeatureLifecycle method.
		AddFeatureLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v3.ProjectMonitorGraphLifecycle
		}
		// AddHandler holds details about calls to the AddHandler method.
		AddHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// Sync is the sync argument value.
			Sync v3.ProjectMonitorGraphHandlerFunc
		}
		// AddLifecycle holds details about calls to the AddLifecycle method.
		AddLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v3.ProjectMonitorGraphLifecycle
		}
		// Controller holds details about calls to the Controller method.
		Controller []struct {
		}
		// Create holds details about calls to the Create method.
		Create []struct {
			// In1 is the in1 argument value.
			In1 *v3.ProjectMonitorGraph
		}
		// Delete holds details about calls to the Delete method.
		Delete []struct {
			// Name is the name argument value.
			Name string
			// Options is the options argument value.
			Options *v1.DeleteOptions
		}
		// DeleteCollection holds details about calls to the DeleteCollection method.
		DeleteCollection []struct {
			// DeleteOpts is the deleteOpts argument value.
			DeleteOpts *v1.DeleteOptions
			// ListOpts is the listOpts argument value.
			ListOpts v1.ListOptions
		}
		// DeleteNamespaced holds details about calls to the DeleteNamespaced method.
		DeleteNamespaced []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
			// Options is the options argument value.
			Options *v1.DeleteOptions
		}
		// Get holds details about calls to the Get method.
		Get []struct {
			// Name is the name argument value.
			Name string
			// Opts is the opts argument value.
			Opts v1.GetOptions
		}
		// GetNamespaced holds details about calls to the GetNamespaced method.
		GetNamespaced []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
			// Opts is the opts argument value.
			Opts v1.GetOptions
		}
		// List holds details about calls to the List method.
		List []struct {
			// Opts is the opts argument value.
			Opts v1.ListOptions
		}
		// ListNamespaced holds details about calls to the ListNamespaced method.
		ListNamespaced []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Opts is the opts argument value.
			Opts v1.ListOptions
		}
		// ObjectClient holds details about calls to the ObjectClient method.
		ObjectClient []struct {
		}
		// Update holds details about calls to the Update method.
		Update []struct {
			// In1 is the in1 argument value.
			In1 *v3.ProjectMonitorGraph
		}
		// Watch holds details about calls to the Watch method.
		Watch []struct {
			// Opts is the opts argument value.
			Opts v1.ListOptions
		}
	}
}

// AddClusterScopedFeatureHandler calls AddClusterScopedFeatureHandlerFunc.
func (mock *ProjectMonitorGraphInterfaceMock) AddClusterScopedFeatureHandler(ctx context.Context, enabled func() bool, name string, clusterName string, sync v3.ProjectMonitorGraphHandlerFunc) {
	if mock.AddClusterScopedFeatureHandlerFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.AddClusterScopedFeatureHandlerFunc: method is nil but ProjectMonitorGraphInterface.AddClusterScopedFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Sync        v3.ProjectMonitorGraphHandlerFunc
	}{
		Ctx:         ctx,
		Enabled:     enabled,
		Name:        name,
		ClusterName: clusterName,
		Sync:        sync,
	}
	lockProjectMonitorGraphInterfaceMockAddClusterScopedFeatureHandler.Lock()
	mock.calls.AddClusterScopedFeatureHandler = append(mock.calls.AddClusterScopedFeatureHandler, callInfo)
	lockProjectMonitorGraphInterfaceMockAddClusterScopedFeatureHandler.Unlock()
	mock.AddClusterScopedFeatureHandlerFunc(ctx, enabled, name, clusterName, sync)
}

// AddClusterScopedFeatureHandlerCalls gets all the calls that were made to AddClusterScopedFeatureHandler.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.AddClusterScopedFeatureHandlerCalls())
func (mock *ProjectMonitorGraphInterfaceMock) AddClusterScopedFeatureHandlerCalls() []struct {
	Ctx         context.Context
	Enabled     func() bool
	Name        string
	ClusterName string
	Sync        v3.ProjectMonitorGraphHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Sync        v3.ProjectMonitorGraphHandlerFunc
	}
	lockProjectMonitorGraphInterfaceMockAddClusterScopedFeatureHandler.RLock()
	calls = mock.calls.AddClusterScopedFeatureHandler
	lockProjectMonitorGraphInterfaceMockAddClusterScopedFeatureHandler.RUnlock()
	return calls
}

// AddClusterScopedFeatureLifecycle calls AddClusterScopedFeatureLifecycleFunc.
func (mock *ProjectMonitorGraphInterfaceMock) AddClusterScopedFeatureLifecycle(ctx context.Context, enabled func() bool, name string, clusterName string, lifecycle v3.ProjectMonitorGraphLifecycle) {
	if mock.AddClusterScopedFeatureLifecycleFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.AddClusterScopedFeatureLifecycleFunc: method is nil but ProjectMonitorGraphInterface.AddClusterScopedFeatureLifecycle was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Lifecycle   v3.ProjectMonitorGraphLifecycle
	}{
		Ctx:         ctx,
		Enabled:     enabled,
		Name:        name,
		ClusterName: clusterName,
		Lifecycle:   lifecycle,
	}
	lockProjectMonitorGraphInterfaceMockAddClusterScopedFeatureLifecycle.Lock()
	mock.calls.AddClusterScopedFeatureLifecycle = append(mock.calls.AddClusterScopedFeatureLifecycle, callInfo)
	lockProjectMonitorGraphInterfaceMockAddClusterScopedFeatureLifecycle.Unlock()
	mock.AddClusterScopedFeatureLifecycleFunc(ctx, enabled, name, clusterName, lifecycle)
}

// AddClusterScopedFeatureLifecycleCalls gets all the calls that were made to AddClusterScopedFeatureLifecycle.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.AddClusterScopedFeatureLifecycleCalls())
func (mock *ProjectMonitorGraphInterfaceMock) AddClusterScopedFeatureLifecycleCalls() []struct {
	Ctx         context.Context
	Enabled     func() bool
	Name        string
	ClusterName string
	Lifecycle   v3.ProjectMonitorGraphLifecycle
} {
	var calls []struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Lifecycle   v3.ProjectMonitorGraphLifecycle
	}
	lockProjectMonitorGraphInterfaceMockAddClusterScopedFeatureLifecycle.RLock()
	calls = mock.calls.AddClusterScopedFeatureLifecycle
	lockProjectMonitorGraphInterfaceMockAddClusterScopedFeatureLifecycle.RUnlock()
	return calls
}

// AddClusterScopedHandler calls AddClusterScopedHandlerFunc.
func (mock *ProjectMonitorGraphInterfaceMock) AddClusterScopedHandler(ctx context.Context, name string, clusterName string, sync v3.ProjectMonitorGraphHandlerFunc) {
	if mock.AddClusterScopedHandlerFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.AddClusterScopedHandlerFunc: method is nil but ProjectMonitorGraphInterface.AddClusterScopedHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Sync        v3.ProjectMonitorGraphHandlerFunc
	}{
		Ctx:         ctx,
		Name:        name,
		ClusterName: clusterName,
		Sync:        sync,
	}
	lockProjectMonitorGraphInterfaceMockAddClusterScopedHandler.Lock()
	mock.calls.AddClusterScopedHandler = append(mock.calls.AddClusterScopedHandler, callInfo)
	lockProjectMonitorGraphInterfaceMockAddClusterScopedHandler.Unlock()
	mock.AddClusterScopedHandlerFunc(ctx, name, clusterName, sync)
}

// AddClusterScopedHandlerCalls gets all the calls that were made to AddClusterScopedHandler.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.AddClusterScopedHandlerCalls())
func (mock *ProjectMonitorGraphInterfaceMock) AddClusterScopedHandlerCalls() []struct {
	Ctx         context.Context
	Name        string
	ClusterName string
	Sync        v3.ProjectMonitorGraphHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Sync        v3.ProjectMonitorGraphHandlerFunc
	}
	lockProjectMonitorGraphInterfaceMockAddClusterScopedHandler.RLock()
	calls = mock.calls.AddClusterScopedHandler
	lockProjectMonitorGraphInterfaceMockAddClusterScopedHandler.RUnlock()
	return calls
}

// AddClusterScopedLifecycle calls AddClusterScopedLifecycleFunc.
func (mock *ProjectMonitorGraphInterfaceMock) AddClusterScopedLifecycle(ctx context.Context, name string, clusterName string, lifecycle v3.ProjectMonitorGraphLifecycle) {
	if mock.AddClusterScopedLifecycleFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.AddClusterScopedLifecycleFunc: method is nil but ProjectMonitorGraphInterface.AddClusterScopedLifecycle was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Lifecycle   v3.ProjectMonitorGraphLifecycle
	}{
		Ctx:         ctx,
		Name:        name,
		ClusterName: clusterName,
		Lifecycle:   lifecycle,
	}
	lockProjectMonitorGraphInterfaceMockAddClusterScopedLifecycle.Lock()
	mock.calls.AddClusterScopedLifecycle = append(mock.calls.AddClusterScopedLifecycle, callInfo)
	lockProjectMonitorGraphInterfaceMockAddClusterScopedLifecycle.Unlock()
	mock.AddClusterScopedLifecycleFunc(ctx, name, clusterName, lifecycle)
}

// AddClusterScopedLifecycleCalls gets all the calls that were made to AddClusterScopedLifecycle.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.AddClusterScopedLifecycleCalls())
func (mock *ProjectMonitorGraphInterfaceMock) AddClusterScopedLifecycleCalls() []struct {
	Ctx         context.Context
	Name        string
	ClusterName string
	Lifecycle   v3.ProjectMonitorGraphLifecycle
} {
	var calls []struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Lifecycle   v3.ProjectMonitorGraphLifecycle
	}
	lockProjectMonitorGraphInterfaceMockAddClusterScopedLifecycle.RLock()
	calls = mock.calls.AddClusterScopedLifecycle
	lockProjectMonitorGraphInterfaceMockAddClusterScopedLifecycle.RUnlock()
	return calls
}

// AddFeatureHandler calls AddFeatureHandlerFunc.
func (mock *ProjectMonitorGraphInterfaceMock) AddFeatureHandler(ctx context.Context, enabled func() bool, name string, sync v3.ProjectMonitorGraphHandlerFunc) {
	if mock.AddFeatureHandlerFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.AddFeatureHandlerFunc: method is nil but ProjectMonitorGraphInterface.AddFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v3.ProjectMonitorGraphHandlerFunc
	}{
		Ctx:     ctx,
		Enabled: enabled,
		Name:    name,
		Sync:    sync,
	}
	lockProjectMonitorGraphInterfaceMockAddFeatureHandler.Lock()
	mock.calls.AddFeatureHandler = append(mock.calls.AddFeatureHandler, callInfo)
	lockProjectMonitorGraphInterfaceMockAddFeatureHandler.Unlock()
	mock.AddFeatureHandlerFunc(ctx, enabled, name, sync)
}

// AddFeatureHandlerCalls gets all the calls that were made to AddFeatureHandler.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.AddFeatureHandlerCalls())
func (mock *ProjectMonitorGraphInterfaceMock) AddFeatureHandlerCalls() []struct {
	Ctx     context.Context
	Enabled func() bool
	Name    string
	Sync    v3.ProjectMonitorGraphHandlerFunc
} {
	var calls []struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v3.ProjectMonitorGraphHandlerFunc
	}
	lockProjectMonitorGraphInterfaceMockAddFeatureHandler.RLock()
	calls = mock.calls.AddFeatureHandler
	lockProjectMonitorGraphInterfaceMockAddFeatureHandler.RUnlock()
	return calls
}

// AddFeatureLifecycle calls AddFeatureLifecycleFunc.
func (mock *ProjectMonitorGraphInterfaceMock) AddFeatureLifecycle(ctx context.Context, enabled func() bool, name string, lifecycle v3.ProjectMonitorGraphLifecycle) {
	if mock.AddFeatureLifecycleFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.AddFeatureLifecycleFunc: method is nil but ProjectMonitorGraphInterface.AddFeatureLifecycle was just called")
	}
	callInfo := struct {
		Ctx       context.Context
		Enabled   func() bool
		Name      string
		Lifecycle v3.ProjectMonitorGraphLifecycle
	}{
		Ctx:       ctx,
		Enabled:   enabled,
		Name:      name,
		Lifecycle: lifecycle,
	}
	lockProjectMonitorGraphInterfaceMockAddFeatureLifecycle.Lock()
	mock.calls.AddFeatureLifecycle = append(mock.calls.AddFeatureLifecycle, callInfo)
	lockProjectMonitorGraphInterfaceMockAddFeatureLifecycle.Unlock()
	mock.AddFeatureLifecycleFunc(ctx, enabled, name, lifecycle)
}

// AddFeatureLifecycleCalls gets all the calls that were made to AddFeatureLifecycle.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.AddFeatureLifecycleCalls())
func (mock *ProjectMonitorGraphInterfaceMock) AddFeatureLifecycleCalls() []struct {
	Ctx       context.Context
	Enabled   func() bool
	Name      string
	Lifecycle v3.ProjectMonitorGraphLifecycle
} {
	var calls []struct {
		Ctx       context.Context
		Enabled   func() bool
		Name      string
		Lifecycle v3.ProjectMonitorGraphLifecycle
	}
	lockProjectMonitorGraphInterfaceMockAddFeatureLifecycle.RLock()
	calls = mock.calls.AddFeatureLifecycle
	lockProjectMonitorGraphInterfaceMockAddFeatureLifecycle.RUnlock()
	return calls
}

// AddHandler calls AddHandlerFunc.
func (mock *ProjectMonitorGraphInterfaceMock) AddHandler(ctx context.Context, name string, sync v3.ProjectMonitorGraphHandlerFunc) {
	if mock.AddHandlerFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.AddHandlerFunc: method is nil but ProjectMonitorGraphInterface.AddHandler was just called")
	}
	callInfo := struct {
		Ctx  context.Context
		Name string
		Sync v3.ProjectMonitorGraphHandlerFunc
	}{
		Ctx:  ctx,
		Name: name,
		Sync: sync,
	}
	lockProjectMonitorGraphInterfaceMockAddHandler.Lock()
	mock.calls.AddHandler = append(mock.calls.AddHandler, callInfo)
	lockProjectMonitorGraphInterfaceMockAddHandler.Unlock()
	mock.AddHandlerFunc(ctx, name, sync)
}

// AddHandlerCalls gets all the calls that were made to AddHandler.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.AddHandlerCalls())
func (mock *ProjectMonitorGraphInterfaceMock) AddHandlerCalls() []struct {
	Ctx  context.Context
	Name string
	Sync v3.ProjectMonitorGraphHandlerFunc
} {
	var calls []struct {
		Ctx  context.Context
		Name string
		Sync v3.ProjectMonitorGraphHandlerFunc
	}
	lockProjectMonitorGraphInterfaceMockAddHandler.RLock()
	calls = mock.calls.AddHandler
	lockProjectMonitorGraphInterfaceMockAddHandler.RUnlock()
	return calls
}

// AddLifecycle calls AddLifecycleFunc.
func (mock *ProjectMonitorGraphInterfaceMock) AddLifecycle(ctx context.Context, name string, lifecycle v3.ProjectMonitorGraphLifecycle) {
	if mock.AddLifecycleFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.AddLifecycleFunc: method is nil but ProjectMonitorGraphInterface.AddLifecycle was just called")
	}
	callInfo := struct {
		Ctx       context.Context
		Name      string
		Lifecycle v3.ProjectMonitorGraphLifecycle
	}{
		Ctx:       ctx,
		Name:      name,
		Lifecycle: lifecycle,
	}
	lockProjectMonitorGraphInterfaceMockAddLifecycle.Lock()
	mock.calls.AddLifecycle = append(mock.calls.AddLifecycle, callInfo)
	lockProjectMonitorGraphInterfaceMockAddLifecycle.Unlock()
	mock.AddLifecycleFunc(ctx, name, lifecycle)
}

// AddLifecycleCalls gets all the calls that were made to AddLifecycle.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.AddLifecycleCalls())
func (mock *ProjectMonitorGraphInterfaceMock) AddLifecycleCalls() []struct {
	Ctx       context.Context
	Name      string
	Lifecycle v3.ProjectMonitorGraphLifecycle
} {
	var calls []struct {
		Ctx       context.Context
		Name      string
		Lifecycle v3.ProjectMonitorGraphLifecycle
	}
	lockProjectMonitorGraphInterfaceMockAddLifecycle.RLock()
	calls = mock.calls.AddLifecycle
	lockProjectMonitorGraphInterfaceMockAddLifecycle.RUnlock()
	return calls
}

// Controller calls ControllerFunc.
func (mock *ProjectMonitorGraphInterfaceMock) Controller() v3.ProjectMonitorGraphController {
	if mock.ControllerFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.ControllerFunc: method is nil but ProjectMonitorGraphInterface.Controller was just called")
	}
	callInfo := struct {
	}{}
	lockProjectMonitorGraphInterfaceMockController.Lock()
	mock.calls.Controller = append(mock.calls.Controller, callInfo)
	lockProjectMonitorGraphInterfaceMockController.Unlock()
	return mock.ControllerFunc()
}

// ControllerCalls gets all the calls that were made to Controller.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.ControllerCalls())
func (mock *ProjectMonitorGraphInterfaceMock) ControllerCalls() []struct {
} {
	var calls []struct {
	}
	lockProjectMonitorGraphInterfaceMockController.RLock()
	calls = mock.calls.Controller
	lockProjectMonitorGraphInterfaceMockController.RUnlock()
	return calls
}

// Create calls CreateFunc.
func (mock *ProjectMonitorGraphInterfaceMock) Create(in1 *v3.ProjectMonitorGraph) (*v3.ProjectMonitorGraph, error) {
	if mock.CreateFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.CreateFunc: method is nil but ProjectMonitorGraphInterface.Create was just called")
	}
	callInfo := struct {
		In1 *v3.ProjectMonitorGraph
	}{
		In1: in1,
	}
	lockProjectMonitorGraphInterfaceMockCreate.Lock()
	mock.calls.Create = append(mock.calls.Create, callInfo)
	lockProjectMonitorGraphInterfaceMockCreate.Unlock()
	return mock.CreateFunc(in1)
}

// CreateCalls gets all the calls that were made to Create.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.CreateCalls())
func (mock *ProjectMonitorGraphInterfaceMock) CreateCalls() []struct {
	In1 *v3.ProjectMonitorGraph
} {
	var calls []struct {
		In1 *v3.ProjectMonitorGraph
	}
	lockProjectMonitorGraphInterfaceMockCreate.RLock()
	calls = mock.calls.Create
	lockProjectMonitorGraphInterfaceMockCreate.RUnlock()
	return calls
}

// Delete calls DeleteFunc.
func (mock *ProjectMonitorGraphInterfaceMock) Delete(name string, options *v1.DeleteOptions) error {
	if mock.DeleteFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.DeleteFunc: method is nil but ProjectMonitorGraphInterface.Delete was just called")
	}
	callInfo := struct {
		Name    string
		Options *v1.DeleteOptions
	}{
		Name:    name,
		Options: options,
	}
	lockProjectMonitorGraphInterfaceMockDelete.Lock()
	mock.calls.Delete = append(mock.calls.Delete, callInfo)
	lockProjectMonitorGraphInterfaceMockDelete.Unlock()
	return mock.DeleteFunc(name, options)
}

// DeleteCalls gets all the calls that were made to Delete.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.DeleteCalls())
func (mock *ProjectMonitorGraphInterfaceMock) DeleteCalls() []struct {
	Name    string
	Options *v1.DeleteOptions
} {
	var calls []struct {
		Name    string
		Options *v1.DeleteOptions
	}
	lockProjectMonitorGraphInterfaceMockDelete.RLock()
	calls = mock.calls.Delete
	lockProjectMonitorGraphInterfaceMockDelete.RUnlock()
	return calls
}

// DeleteCollection calls DeleteCollectionFunc.
func (mock *ProjectMonitorGraphInterfaceMock) DeleteCollection(deleteOpts *v1.DeleteOptions, listOpts v1.ListOptions) error {
	if mock.DeleteCollectionFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.DeleteCollectionFunc: method is nil but ProjectMonitorGraphInterface.DeleteCollection was just called")
	}
	callInfo := struct {
		DeleteOpts *v1.DeleteOptions
		ListOpts   v1.ListOptions
	}{
		DeleteOpts: deleteOpts,
		ListOpts:   listOpts,
	}
	lockProjectMonitorGraphInterfaceMockDeleteCollection.Lock()
	mock.calls.DeleteCollection = append(mock.calls.DeleteCollection, callInfo)
	lockProjectMonitorGraphInterfaceMockDeleteCollection.Unlock()
	return mock.DeleteCollectionFunc(deleteOpts, listOpts)
}

// DeleteCollectionCalls gets all the calls that were made to DeleteCollection.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.DeleteCollectionCalls())
func (mock *ProjectMonitorGraphInterfaceMock) DeleteCollectionCalls() []struct {
	DeleteOpts *v1.DeleteOptions
	ListOpts   v1.ListOptions
} {
	var calls []struct {
		DeleteOpts *v1.DeleteOptions
		ListOpts   v1.ListOptions
	}
	lockProjectMonitorGraphInterfaceMockDeleteCollection.RLock()
	calls = mock.calls.DeleteCollection
	lockProjectMonitorGraphInterfaceMockDeleteCollection.RUnlock()
	return calls
}

// DeleteNamespaced calls DeleteNamespacedFunc.
func (mock *ProjectMonitorGraphInterfaceMock) DeleteNamespaced(namespace string, name string, options *v1.DeleteOptions) error {
	if mock.DeleteNamespacedFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.DeleteNamespacedFunc: method is nil but ProjectMonitorGraphInterface.DeleteNamespaced was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
		Options   *v1.DeleteOptions
	}{
		Namespace: namespace,
		Name:      name,
		Options:   options,
	}
	lockProjectMonitorGraphInterfaceMockDeleteNamespaced.Lock()
	mock.calls.DeleteNamespaced = append(mock.calls.DeleteNamespaced, callInfo)
	lockProjectMonitorGraphInterfaceMockDeleteNamespaced.Unlock()
	return mock.DeleteNamespacedFunc(namespace, name, options)
}

// DeleteNamespacedCalls gets all the calls that were made to DeleteNamespaced.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.DeleteNamespacedCalls())
func (mock *ProjectMonitorGraphInterfaceMock) DeleteNamespacedCalls() []struct {
	Namespace string
	Name      string
	Options   *v1.DeleteOptions
} {
	var calls []struct {
		Namespace string
		Name      string
		Options   *v1.DeleteOptions
	}
	lockProjectMonitorGraphInterfaceMockDeleteNamespaced.RLock()
	calls = mock.calls.DeleteNamespaced
	lockProjectMonitorGraphInterfaceMockDeleteNamespaced.RUnlock()
	return calls
}

// Get calls GetFunc.
func (mock *ProjectMonitorGraphInterfaceMock) Get(name string, opts v1.GetOptions) (*v3.ProjectMonitorGraph, error) {
	if mock.GetFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.GetFunc: method is nil but ProjectMonitorGraphInterface.Get was just called")
	}
	callInfo := struct {
		Name string
		Opts v1.GetOptions
	}{
		Name: name,
		Opts: opts,
	}
	lockProjectMonitorGraphInterfaceMockGet.Lock()
	mock.calls.Get = append(mock.calls.Get, callInfo)
	lockProjectMonitorGraphInterfaceMockGet.Unlock()
	return mock.GetFunc(name, opts)
}

// GetCalls gets all the calls that were made to Get.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.GetCalls())
func (mock *ProjectMonitorGraphInterfaceMock) GetCalls() []struct {
	Name string
	Opts v1.GetOptions
} {
	var calls []struct {
		Name string
		Opts v1.GetOptions
	}
	lockProjectMonitorGraphInterfaceMockGet.RLock()
	calls = mock.calls.Get
	lockProjectMonitorGraphInterfaceMockGet.RUnlock()
	return calls
}

// GetNamespaced calls GetNamespacedFunc.
func (mock *ProjectMonitorGraphInterfaceMock) GetNamespaced(namespace string, name string, opts v1.GetOptions) (*v3.ProjectMonitorGraph, error) {
	if mock.GetNamespacedFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.GetNamespacedFunc: method is nil but ProjectMonitorGraphInterface.GetNamespaced was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
		Opts      v1.GetOptions
	}{
		Namespace: namespace,
		Name:      name,
		Opts:      opts,
	}
	lockProjectMonitorGraphInterfaceMockGetNamespaced.Lock()
	mock.calls.GetNamespaced = append(mock.calls.GetNamespaced, callInfo)
	lockProjectMonitorGraphInterfaceMockGetNamespaced.Unlock()
	return mock.GetNamespacedFunc(namespace, name, opts)
}

// GetNamespacedCalls gets all the calls that were made to GetNamespaced.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.GetNamespacedCalls())
func (mock *ProjectMonitorGraphInterfaceMock) GetNamespacedCalls() []struct {
	Namespace string
	Name      string
	Opts      v1.GetOptions
} {
	var calls []struct {
		Namespace string
		Name      string
		Opts      v1.GetOptions
	}
	lockProjectMonitorGraphInterfaceMockGetNamespaced.RLock()
	calls = mock.calls.GetNamespaced
	lockProjectMonitorGraphInterfaceMockGetNamespaced.RUnlock()
	return calls
}

// List calls ListFunc.
func (mock *ProjectMonitorGraphInterfaceMock) List(opts v1.ListOptions) (*v3.ProjectMonitorGraphList, error) {
	if mock.ListFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.ListFunc: method is nil but ProjectMonitorGraphInterface.List was just called")
	}
	callInfo := struct {
		Opts v1.ListOptions
	}{
		Opts: opts,
	}
	lockProjectMonitorGraphInterfaceMockList.Lock()
	mock.calls.List = append(mock.calls.List, callInfo)
	lockProjectMonitorGraphInterfaceMockList.Unlock()
	return mock.ListFunc(opts)
}

// ListCalls gets all the calls that were made to List.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.ListCalls())
func (mock *ProjectMonitorGraphInterfaceMock) ListCalls() []struct {
	Opts v1.ListOptions
} {
	var calls []struct {
		Opts v1.ListOptions
	}
	lockProjectMonitorGraphInterfaceMockList.RLock()
	calls = mock.calls.List
	lockProjectMonitorGraphInterfaceMockList.RUnlock()
	return calls
}

// ListNamespaced calls ListNamespacedFunc.
func (mock *ProjectMonitorGraphInterfaceMock) ListNamespaced(namespace string, opts v1.ListOptions) (*v3.ProjectMonitorGraphList, error) {
	if mock.ListNamespacedFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.ListNamespacedFunc: method is nil but ProjectMonitorGraphInterface.ListNamespaced was just called")
	}
	callInfo := struct {
		Namespace string
		Opts      v1.ListOptions
	}{
		Namespace: namespace,
		Opts:      opts,
	}
	lockProjectMonitorGraphInterfaceMockListNamespaced.Lock()
	mock.calls.ListNamespaced = append(mock.calls.ListNamespaced, callInfo)
	lockProjectMonitorGraphInterfaceMockListNamespaced.Unlock()
	return mock.ListNamespacedFunc(namespace, opts)
}

// ListNamespacedCalls gets all the calls that were made to ListNamespaced.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.ListNamespacedCalls())
func (mock *ProjectMonitorGraphInterfaceMock) ListNamespacedCalls() []struct {
	Namespace string
	Opts      v1.ListOptions
} {
	var calls []struct {
		Namespace string
		Opts      v1.ListOptions
	}
	lockProjectMonitorGraphInterfaceMockListNamespaced.RLock()
	calls = mock.calls.ListNamespaced
	lockProjectMonitorGraphInterfaceMockListNamespaced.RUnlock()
	return calls
}

// ObjectClient calls ObjectClientFunc.
func (mock *ProjectMonitorGraphInterfaceMock) ObjectClient() *objectclient.ObjectClient {
	if mock.ObjectClientFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.ObjectClientFunc: method is nil but ProjectMonitorGraphInterface.ObjectClient was just called")
	}
	callInfo := struct {
	}{}
	lockProjectMonitorGraphInterfaceMockObjectClient.Lock()
	mock.calls.ObjectClient = append(mock.calls.ObjectClient, callInfo)
	lockProjectMonitorGraphInterfaceMockObjectClient.Unlock()
	return mock.ObjectClientFunc()
}

// ObjectClientCalls gets all the calls that were made to ObjectClient.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.ObjectClientCalls())
func (mock *ProjectMonitorGraphInterfaceMock) ObjectClientCalls() []struct {
} {
	var calls []struct {
	}
	lockProjectMonitorGraphInterfaceMockObjectClient.RLock()
	calls = mock.calls.ObjectClient
	lockProjectMonitorGraphInterfaceMockObjectClient.RUnlock()
	return calls
}

// Update calls UpdateFunc.
func (mock *ProjectMonitorGraphInterfaceMock) Update(in1 *v3.ProjectMonitorGraph) (*v3.ProjectMonitorGraph, error) {
	if mock.UpdateFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.UpdateFunc: method is nil but ProjectMonitorGraphInterface.Update was just called")
	}
	callInfo := struct {
		In1 *v3.ProjectMonitorGraph
	}{
		In1: in1,
	}
	lockProjectMonitorGraphInterfaceMockUpdate.Lock()
	mock.calls.Update = append(mock.calls.Update, callInfo)
	lockProjectMonitorGraphInterfaceMockUpdate.Unlock()
	return mock.UpdateFunc(in1)
}

// UpdateCalls gets all the calls that were made to Update.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.UpdateCalls())
func (mock *ProjectMonitorGraphInterfaceMock) UpdateCalls() []struct {
	In1 *v3.ProjectMonitorGraph
} {
	var calls []struct {
		In1 *v3.ProjectMonitorGraph
	}
	lockProjectMonitorGraphInterfaceMockUpdate.RLock()
	calls = mock.calls.Update
	lockProjectMonitorGraphInterfaceMockUpdate.RUnlock()
	return calls
}

// Watch calls WatchFunc.
func (mock *ProjectMonitorGraphInterfaceMock) Watch(opts v1.ListOptions) (watch.Interface, error) {
	if mock.WatchFunc == nil {
		panic("ProjectMonitorGraphInterfaceMock.WatchFunc: method is nil but ProjectMonitorGraphInterface.Watch was just called")
	}
	callInfo := struct {
		Opts v1.ListOptions
	}{
		Opts: opts,
	}
	lockProjectMonitorGraphInterfaceMockWatch.Lock()
	mock.calls.Watch = append(mock.calls.Watch, callInfo)
	lockProjectMonitorGraphInterfaceMockWatch.Unlock()
	return mock.WatchFunc(opts)
}

// WatchCalls gets all the calls that were made to Watch.
// Check the length with:
//     len(mockedProjectMonitorGraphInterface.WatchCalls())
func (mock *ProjectMonitorGraphInterfaceMock) WatchCalls() []struct {
	Opts v1.ListOptions
} {
	var calls []struct {
		Opts v1.ListOptions
	}
	lockProjectMonitorGraphInterfaceMockWatch.RLock()
	calls = mock.calls.Watch
	lockProjectMonitorGraphInterfaceMockWatch.RUnlock()
	return calls
}

var (
	lockProjectMonitorGraphsGetterMockProjectMonitorGraphs sync.RWMutex
)

// Ensure, that ProjectMonitorGraphsGetterMock does implement ProjectMonitorGraphsGetter.
// If this is not the case, regenerate this file with moq.
var _ v3.ProjectMonitorGraphsGetter = &ProjectMonitorGraphsGetterMock{}

// ProjectMonitorGraphsGetterMock is a mock implementation of ProjectMonitorGraphsGetter.
//
//     func TestSomethingThatUsesProjectMonitorGraphsGetter(t *testing.T) {
//
//         // make and configure a mocked ProjectMonitorGraphsGetter
//         mockedProjectMonitorGraphsGetter := &ProjectMonitorGraphsGetterMock{
//             ProjectMonitorGraphsFunc: func(namespace string) v3.ProjectMonitorGraphInterface {
// 	               panic("mock out the ProjectMonitorGraphs method")
//             },
//         }
//
//         // use mockedProjectMonitorGraphsGetter in code that requires ProjectMonitorGraphsGetter
//         // and then make assertions.
//
//     }
type ProjectMonitorGraphsGetterMock struct {
	// ProjectMonitorGraphsFunc mocks the ProjectMonitorGraphs method.
	ProjectMonitorGraphsFunc func(namespace string) v3.ProjectMonitorGraphInterface

	// calls tracks calls to the methods.
	calls struct {
		// ProjectMonitorGraphs holds details about calls to the ProjectMonitorGraphs method.
		ProjectMonitorGraphs []struct {
			// Namespace is the namespace argument value.
			Namespace string
		}
	}
}

// ProjectMonitorGraphs calls ProjectMonitorGraphsFunc.
func (mock *ProjectMonitorGraphsGetterMock) ProjectMonitorGraphs(namespace string) v3.ProjectMonitorGraphInterface {
	if mock.ProjectMonitorGraphsFunc == nil {
		panic("ProjectMonitorGraphsGetterMock.ProjectMonitorGraphsFunc: method is nil but ProjectMonitorGraphsGetter.ProjectMonitorGraphs was just called")
	}
	callInfo := struct {
		Namespace string
	}{
		Namespace: namespace,
	}
	lockProjectMonitorGraphsGetterMockProjectMonitorGraphs.Lock()
	mock.calls.ProjectMonitorGraphs = append(mock.calls.ProjectMonitorGraphs, callInfo)
	lockProjectMonitorGraphsGetterMockProjectMonitorGraphs.Unlock()
	return mock.ProjectMonitorGraphsFunc(namespace)
}

// ProjectMonitorGraphsCalls gets all the calls that were made to ProjectMonitorGraphs.
// Check the length with:
//     len(mockedProjectMonitorGraphsGetter.ProjectMonitorGraphsCalls())
func (mock *ProjectMonitorGraphsGetterMock) ProjectMonitorGraphsCalls() []struct {
	Namespace string
} {
	var calls []struct {
		Namespace string
	}
	lockProjectMonitorGraphsGetterMockProjectMonitorGraphs.RLock()
	calls = mock.calls.ProjectMonitorGraphs
	lockProjectMonitorGraphsGetterMockProjectMonitorGraphs.RUnlock()
	return calls
}
