// Code generated by moq; DO NOT EDIT.
// github.com/matryer/moq

package fakes

import (
	context "context"
	sync "sync"
	time "time"

	controller "github.com/rancher/norman/controller"
	objectclient "github.com/rancher/norman/objectclient"
	v3 "github.com/rancher/types/apis/project.cattle.io/v3"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

var (
	lockSourceCodeProviderConfigListerMockGet  sync.RWMutex
	lockSourceCodeProviderConfigListerMockList sync.RWMutex
)

// Ensure, that SourceCodeProviderConfigListerMock does implement SourceCodeProviderConfigLister.
// If this is not the case, regenerate this file with moq.
var _ v3.SourceCodeProviderConfigLister = &SourceCodeProviderConfigListerMock{}

// SourceCodeProviderConfigListerMock is a mock implementation of SourceCodeProviderConfigLister.
//
//     func TestSomethingThatUsesSourceCodeProviderConfigLister(t *testing.T) {
//
//         // make and configure a mocked SourceCodeProviderConfigLister
//         mockedSourceCodeProviderConfigLister := &SourceCodeProviderConfigListerMock{
//             GetFunc: func(namespace string, name string) (*v3.SourceCodeProviderConfig, error) {
// 	               panic("mock out the Get method")
//             },
//             ListFunc: func(namespace string, selector labels.Selector) ([]*v3.SourceCodeProviderConfig, error) {
// 	               panic("mock out the List method")
//             },
//         }
//
//         // use mockedSourceCodeProviderConfigLister in code that requires SourceCodeProviderConfigLister
//         // and then make assertions.
//
//     }
type SourceCodeProviderConfigListerMock struct {
	// GetFunc mocks the Get method.
	GetFunc func(namespace string, name string) (*v3.SourceCodeProviderConfig, error)

	// ListFunc mocks the List method.
	ListFunc func(namespace string, selector labels.Selector) ([]*v3.SourceCodeProviderConfig, error)

	// calls tracks calls to the methods.
	calls struct {
		// Get holds details about calls to the Get method.
		Get []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
		}
		// List holds details about calls to the List method.
		List []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Selector is the selector argument value.
			Selector labels.Selector
		}
	}
}

// Get calls GetFunc.
func (mock *SourceCodeProviderConfigListerMock) Get(namespace string, name string) (*v3.SourceCodeProviderConfig, error) {
	if mock.GetFunc == nil {
		panic("SourceCodeProviderConfigListerMock.GetFunc: method is nil but SourceCodeProviderConfigLister.Get was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
	}{
		Namespace: namespace,
		Name:      name,
	}
	lockSourceCodeProviderConfigListerMockGet.Lock()
	mock.calls.Get = append(mock.calls.Get, callInfo)
	lockSourceCodeProviderConfigListerMockGet.Unlock()
	return mock.GetFunc(namespace, name)
}

// GetCalls gets all the calls that were made to Get.
// Check the length with:
//     len(mockedSourceCodeProviderConfigLister.GetCalls())
func (mock *SourceCodeProviderConfigListerMock) GetCalls() []struct {
	Namespace string
	Name      string
} {
	var calls []struct {
		Namespace string
		Name      string
	}
	lockSourceCodeProviderConfigListerMockGet.RLock()
	calls = mock.calls.Get
	lockSourceCodeProviderConfigListerMockGet.RUnlock()
	return calls
}

// List calls ListFunc.
func (mock *SourceCodeProviderConfigListerMock) List(namespace string, selector labels.Selector) ([]*v3.SourceCodeProviderConfig, error) {
	if mock.ListFunc == nil {
		panic("SourceCodeProviderConfigListerMock.ListFunc: method is nil but SourceCodeProviderConfigLister.List was just called")
	}
	callInfo := struct {
		Namespace string
		Selector  labels.Selector
	}{
		Namespace: namespace,
		Selector:  selector,
	}
	lockSourceCodeProviderConfigListerMockList.Lock()
	mock.calls.List = append(mock.calls.List, callInfo)
	lockSourceCodeProviderConfigListerMockList.Unlock()
	return mock.ListFunc(namespace, selector)
}

// ListCalls gets all the calls that were made to List.
// Check the length with:
//     len(mockedSourceCodeProviderConfigLister.ListCalls())
func (mock *SourceCodeProviderConfigListerMock) ListCalls() []struct {
	Namespace string
	Selector  labels.Selector
} {
	var calls []struct {
		Namespace string
		Selector  labels.Selector
	}
	lockSourceCodeProviderConfigListerMockList.RLock()
	calls = mock.calls.List
	lockSourceCodeProviderConfigListerMockList.RUnlock()
	return calls
}

var (
	lockSourceCodeProviderConfigControllerMockAddClusterScopedFeatureHandler sync.RWMutex
	lockSourceCodeProviderConfigControllerMockAddClusterScopedHandler        sync.RWMutex
	lockSourceCodeProviderConfigControllerMockAddFeatureHandler              sync.RWMutex
	lockSourceCodeProviderConfigControllerMockAddHandler                     sync.RWMutex
	lockSourceCodeProviderConfigControllerMockEnqueue                        sync.RWMutex
	lockSourceCodeProviderConfigControllerMockEnqueueAfter                   sync.RWMutex
	lockSourceCodeProviderConfigControllerMockGeneric                        sync.RWMutex
	lockSourceCodeProviderConfigControllerMockInformer                       sync.RWMutex
	lockSourceCodeProviderConfigControllerMockLister                         sync.RWMutex
)

// Ensure, that SourceCodeProviderConfigControllerMock does implement SourceCodeProviderConfigController.
// If this is not the case, regenerate this file with moq.
var _ v3.SourceCodeProviderConfigController = &SourceCodeProviderConfigControllerMock{}

// SourceCodeProviderConfigControllerMock is a mock implementation of SourceCodeProviderConfigController.
//
//     func TestSomethingThatUsesSourceCodeProviderConfigController(t *testing.T) {
//
//         // make and configure a mocked SourceCodeProviderConfigController
//         mockedSourceCodeProviderConfigController := &SourceCodeProviderConfigControllerMock{
//             AddClusterScopedFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, clusterName string, handler v3.SourceCodeProviderConfigHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedFeatureHandler method")
//             },
//             AddClusterScopedHandlerFunc: func(ctx context.Context, name string, clusterName string, handler v3.SourceCodeProviderConfigHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedHandler method")
//             },
//             AddFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, sync v3.SourceCodeProviderConfigHandlerFunc)  {
// 	               panic("mock out the AddFeatureHandler method")
//             },
//             AddHandlerFunc: func(ctx context.Context, name string, handler v3.SourceCodeProviderConfigHandlerFunc)  {
// 	               panic("mock out the AddHandler method")
//             },
//             EnqueueFunc: func(namespace string, name string)  {
// 	               panic("mock out the Enqueue method")
//             },
//             EnqueueAfterFunc: func(namespace string, name string, after time.Duration)  {
// 	               panic("mock out the EnqueueAfter method")
//             },
//             GenericFunc: func() controller.GenericController {
// 	               panic("mock out the Generic method")
//             },
//             InformerFunc: func() cache.SharedIndexInformer {
// 	               panic("mock out the Informer method")
//             },
//             ListerFunc: func() v3.SourceCodeProviderConfigLister {
// 	               panic("mock out the Lister method")
//             },
//         }
//
//         // use mockedSourceCodeProviderConfigController in code that requires SourceCodeProviderConfigController
//         // and then make assertions.
//
//     }
type SourceCodeProviderConfigControllerMock struct {
	// AddClusterScopedFeatureHandlerFunc mocks the AddClusterScopedFeatureHandler method.
	AddClusterScopedFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, clusterName string, handler v3.SourceCodeProviderConfigHandlerFunc)

	// AddClusterScopedHandlerFunc mocks the AddClusterScopedHandler method.
	AddClusterScopedHandlerFunc func(ctx context.Context, name string, clusterName string, handler v3.SourceCodeProviderConfigHandlerFunc)

	// AddFeatureHandlerFunc mocks the AddFeatureHandler method.
	AddFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, sync v3.SourceCodeProviderConfigHandlerFunc)

	// AddHandlerFunc mocks the AddHandler method.
	AddHandlerFunc func(ctx context.Context, name string, handler v3.SourceCodeProviderConfigHandlerFunc)

	// EnqueueFunc mocks the Enqueue method.
	EnqueueFunc func(namespace string, name string)

	// EnqueueAfterFunc mocks the EnqueueAfter method.
	EnqueueAfterFunc func(namespace string, name string, after time.Duration)

	// GenericFunc mocks the Generic method.
	GenericFunc func() controller.GenericController

	// InformerFunc mocks the Informer method.
	InformerFunc func() cache.SharedIndexInformer

	// ListerFunc mocks the Lister method.
	ListerFunc func() v3.SourceCodeProviderConfigLister

	// calls tracks calls to the methods.
	calls struct {
		// AddClusterScopedFeatureHandler holds details about calls to the AddClusterScopedFeatureHandler method.
		AddClusterScopedFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Handler is the handler argument value.
			Handler v3.SourceCodeProviderConfigHandlerFunc
		}
		// AddClusterScopedHandler holds details about calls to the AddClusterScopedHandler method.
		AddClusterScopedHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Handler is the handler argument value.
			Handler v3.SourceCodeProviderConfigHandlerFunc
		}
		// AddFeatureHandler holds details about calls to the AddFeatureHandler method.
		AddFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// Sync is the sync argument value.
			Sync v3.SourceCodeProviderConfigHandlerFunc
		}
		// AddHandler holds details about calls to the AddHandler method.
		AddHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// Handler is the handler argument value.
			Handler v3.SourceCodeProviderConfigHandlerFunc
		}
		// Enqueue holds details about calls to the Enqueue method.
		Enqueue []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
		}
		// EnqueueAfter holds details about calls to the EnqueueAfter method.
		EnqueueAfter []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
			// After is the after argument value.
			After time.Duration
		}
		// Generic holds details about calls to the Generic method.
		Generic []struct {
		}
		// Informer holds details about calls to the Informer method.
		Informer []struct {
		}
		// Lister holds details about calls to the Lister method.
		Lister []struct {
		}
	}
}

// AddClusterScopedFeatureHandler calls AddClusterScopedFeatureHandlerFunc.
func (mock *SourceCodeProviderConfigControllerMock) AddClusterScopedFeatureHandler(ctx context.Context, enabled func() bool, name string, clusterName string, handler v3.SourceCodeProviderConfigHandlerFunc) {
	if mock.AddClusterScopedFeatureHandlerFunc == nil {
		panic("SourceCodeProviderConfigControllerMock.AddClusterScopedFeatureHandlerFunc: method is nil but SourceCodeProviderConfigController.AddClusterScopedFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Handler     v3.SourceCodeProviderConfigHandlerFunc
	}{
		Ctx:         ctx,
		Enabled:     enabled,
		Name:        name,
		ClusterName: clusterName,
		Handler:     handler,
	}
	lockSourceCodeProviderConfigControllerMockAddClusterScopedFeatureHandler.Lock()
	mock.calls.AddClusterScopedFeatureHandler = append(mock.calls.AddClusterScopedFeatureHandler, callInfo)
	lockSourceCodeProviderConfigControllerMockAddClusterScopedFeatureHandler.Unlock()
	mock.AddClusterScopedFeatureHandlerFunc(ctx, enabled, name, clusterName, handler)
}

// AddClusterScopedFeatureHandlerCalls gets all the calls that were made to AddClusterScopedFeatureHandler.
// Check the length with:
//     len(mockedSourceCodeProviderConfigController.AddClusterScopedFeatureHandlerCalls())
func (mock *SourceCodeProviderConfigControllerMock) AddClusterScopedFeatureHandlerCalls() []struct {
	Ctx         context.Context
	Enabled     func() bool
	Name        string
	ClusterName string
	Handler     v3.SourceCodeProviderConfigHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Handler     v3.SourceCodeProviderConfigHandlerFunc
	}
	lockSourceCodeProviderConfigControllerMockAddClusterScopedFeatureHandler.RLock()
	calls = mock.calls.AddClusterScopedFeatureHandler
	lockSourceCodeProviderConfigControllerMockAddClusterScopedFeatureHandler.RUnlock()
	return calls
}

// AddClusterScopedHandler calls AddClusterScopedHandlerFunc.
func (mock *SourceCodeProviderConfigControllerMock) AddClusterScopedHandler(ctx context.Context, name string, clusterName string, handler v3.SourceCodeProviderConfigHandlerFunc) {
	if mock.AddClusterScopedHandlerFunc == nil {
		panic("SourceCodeProviderConfigControllerMock.AddClusterScopedHandlerFunc: method is nil but SourceCodeProviderConfigController.AddClusterScopedHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Handler     v3.SourceCodeProviderConfigHandlerFunc
	}{
		Ctx:         ctx,
		Name:        name,
		ClusterName: clusterName,
		Handler:     handler,
	}
	lockSourceCodeProviderConfigControllerMockAddClusterScopedHandler.Lock()
	mock.calls.AddClusterScopedHandler = append(mock.calls.AddClusterScopedHandler, callInfo)
	lockSourceCodeProviderConfigControllerMockAddClusterScopedHandler.Unlock()
	mock.AddClusterScopedHandlerFunc(ctx, name, clusterName, handler)
}

// AddClusterScopedHandlerCalls gets all the calls that were made to AddClusterScopedHandler.
// Check the length with:
//     len(mockedSourceCodeProviderConfigController.AddClusterScopedHandlerCalls())
func (mock *SourceCodeProviderConfigControllerMock) AddClusterScopedHandlerCalls() []struct {
	Ctx         context.Context
	Name        string
	ClusterName string
	Handler     v3.SourceCodeProviderConfigHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Handler     v3.SourceCodeProviderConfigHandlerFunc
	}
	lockSourceCodeProviderConfigControllerMockAddClusterScopedHandler.RLock()
	calls = mock.calls.AddClusterScopedHandler
	lockSourceCodeProviderConfigControllerMockAddClusterScopedHandler.RUnlock()
	return calls
}

// AddFeatureHandler calls AddFeatureHandlerFunc.
func (mock *SourceCodeProviderConfigControllerMock) AddFeatureHandler(ctx context.Context, enabled func() bool, name string, sync v3.SourceCodeProviderConfigHandlerFunc) {
	if mock.AddFeatureHandlerFunc == nil {
		panic("SourceCodeProviderConfigControllerMock.AddFeatureHandlerFunc: method is nil but SourceCodeProviderConfigController.AddFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v3.SourceCodeProviderConfigHandlerFunc
	}{
		Ctx:     ctx,
		Enabled: enabled,
		Name:    name,
		Sync:    sync,
	}
	lockSourceCodeProviderConfigControllerMockAddFeatureHandler.Lock()
	mock.calls.AddFeatureHandler = append(mock.calls.AddFeatureHandler, callInfo)
	lockSourceCodeProviderConfigControllerMockAddFeatureHandler.Unlock()
	mock.AddFeatureHandlerFunc(ctx, enabled, name, sync)
}

// AddFeatureHandlerCalls gets all the calls that were made to AddFeatureHandler.
// Check the length with:
//     len(mockedSourceCodeProviderConfigController.AddFeatureHandlerCalls())
func (mock *SourceCodeProviderConfigControllerMock) AddFeatureHandlerCalls() []struct {
	Ctx     context.Context
	Enabled func() bool
	Name    string
	Sync    v3.SourceCodeProviderConfigHandlerFunc
} {
	var calls []struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v3.SourceCodeProviderConfigHandlerFunc
	}
	lockSourceCodeProviderConfigControllerMockAddFeatureHandler.RLock()
	calls = mock.calls.AddFeatureHandler
	lockSourceCodeProviderConfigControllerMockAddFeatureHandler.RUnlock()
	return calls
}

// AddHandler calls AddHandlerFunc.
func (mock *SourceCodeProviderConfigControllerMock) AddHandler(ctx context.Context, name string, handler v3.SourceCodeProviderConfigHandlerFunc) {
	if mock.AddHandlerFunc == nil {
		panic("SourceCodeProviderConfigControllerMock.AddHandlerFunc: method is nil but SourceCodeProviderConfigController.AddHandler was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Name    string
		Handler v3.SourceCodeProviderConfigHandlerFunc
	}{
		Ctx:     ctx,
		Name:    name,
		Handler: handler,
	}
	lockSourceCodeProviderConfigControllerMockAddHandler.Lock()
	mock.calls.AddHandler = append(mock.calls.AddHandler, callInfo)
	lockSourceCodeProviderConfigControllerMockAddHandler.Unlock()
	mock.AddHandlerFunc(ctx, name, handler)
}

// AddHandlerCalls gets all the calls that were made to AddHandler.
// Check the length with:
//     len(mockedSourceCodeProviderConfigController.AddHandlerCalls())
func (mock *SourceCodeProviderConfigControllerMock) AddHandlerCalls() []struct {
	Ctx     context.Context
	Name    string
	Handler v3.SourceCodeProviderConfigHandlerFunc
} {
	var calls []struct {
		Ctx     context.Context
		Name    string
		Handler v3.SourceCodeProviderConfigHandlerFunc
	}
	lockSourceCodeProviderConfigControllerMockAddHandler.RLock()
	calls = mock.calls.AddHandler
	lockSourceCodeProviderConfigControllerMockAddHandler.RUnlock()
	return calls
}

// Enqueue calls EnqueueFunc.
func (mock *SourceCodeProviderConfigControllerMock) Enqueue(namespace string, name string) {
	if mock.EnqueueFunc == nil {
		panic("SourceCodeProviderConfigControllerMock.EnqueueFunc: method is nil but SourceCodeProviderConfigController.Enqueue was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
	}{
		Namespace: namespace,
		Name:      name,
	}
	lockSourceCodeProviderConfigControllerMockEnqueue.Lock()
	mock.calls.Enqueue = append(mock.calls.Enqueue, callInfo)
	lockSourceCodeProviderConfigControllerMockEnqueue.Unlock()
	mock.EnqueueFunc(namespace, name)
}

// EnqueueCalls gets all the calls that were made to Enqueue.
// Check the length with:
//     len(mockedSourceCodeProviderConfigController.EnqueueCalls())
func (mock *SourceCodeProviderConfigControllerMock) EnqueueCalls() []struct {
	Namespace string
	Name      string
} {
	var calls []struct {
		Namespace string
		Name      string
	}
	lockSourceCodeProviderConfigControllerMockEnqueue.RLock()
	calls = mock.calls.Enqueue
	lockSourceCodeProviderConfigControllerMockEnqueue.RUnlock()
	return calls
}

// EnqueueAfter calls EnqueueAfterFunc.
func (mock *SourceCodeProviderConfigControllerMock) EnqueueAfter(namespace string, name string, after time.Duration) {
	if mock.EnqueueAfterFunc == nil {
		panic("SourceCodeProviderConfigControllerMock.EnqueueAfterFunc: method is nil but SourceCodeProviderConfigController.EnqueueAfter was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
		After     time.Duration
	}{
		Namespace: namespace,
		Name:      name,
		After:     after,
	}
	lockSourceCodeProviderConfigControllerMockEnqueueAfter.Lock()
	mock.calls.EnqueueAfter = append(mock.calls.EnqueueAfter, callInfo)
	lockSourceCodeProviderConfigControllerMockEnqueueAfter.Unlock()
	mock.EnqueueAfterFunc(namespace, name, after)
}

// EnqueueAfterCalls gets all the calls that were made to EnqueueAfter.
// Check the length with:
//     len(mockedSourceCodeProviderConfigController.EnqueueAfterCalls())
func (mock *SourceCodeProviderConfigControllerMock) EnqueueAfterCalls() []struct {
	Namespace string
	Name      string
	After     time.Duration
} {
	var calls []struct {
		Namespace string
		Name      string
		After     time.Duration
	}
	lockSourceCodeProviderConfigControllerMockEnqueueAfter.RLock()
	calls = mock.calls.EnqueueAfter
	lockSourceCodeProviderConfigControllerMockEnqueueAfter.RUnlock()
	return calls
}

// Generic calls GenericFunc.
func (mock *SourceCodeProviderConfigControllerMock) Generic() controller.GenericController {
	if mock.GenericFunc == nil {
		panic("SourceCodeProviderConfigControllerMock.GenericFunc: method is nil but SourceCodeProviderConfigController.Generic was just called")
	}
	callInfo := struct {
	}{}
	lockSourceCodeProviderConfigControllerMockGeneric.Lock()
	mock.calls.Generic = append(mock.calls.Generic, callInfo)
	lockSourceCodeProviderConfigControllerMockGeneric.Unlock()
	return mock.GenericFunc()
}

// GenericCalls gets all the calls that were made to Generic.
// Check the length with:
//     len(mockedSourceCodeProviderConfigController.GenericCalls())
func (mock *SourceCodeProviderConfigControllerMock) GenericCalls() []struct {
} {
	var calls []struct {
	}
	lockSourceCodeProviderConfigControllerMockGeneric.RLock()
	calls = mock.calls.Generic
	lockSourceCodeProviderConfigControllerMockGeneric.RUnlock()
	return calls
}

// Informer calls InformerFunc.
func (mock *SourceCodeProviderConfigControllerMock) Informer() cache.SharedIndexInformer {
	if mock.InformerFunc == nil {
		panic("SourceCodeProviderConfigControllerMock.InformerFunc: method is nil but SourceCodeProviderConfigController.Informer was just called")
	}
	callInfo := struct {
	}{}
	lockSourceCodeProviderConfigControllerMockInformer.Lock()
	mock.calls.Informer = append(mock.calls.Informer, callInfo)
	lockSourceCodeProviderConfigControllerMockInformer.Unlock()
	return mock.InformerFunc()
}

// InformerCalls gets all the calls that were made to Informer.
// Check the length with:
//     len(mockedSourceCodeProviderConfigController.InformerCalls())
func (mock *SourceCodeProviderConfigControllerMock) InformerCalls() []struct {
} {
	var calls []struct {
	}
	lockSourceCodeProviderConfigControllerMockInformer.RLock()
	calls = mock.calls.Informer
	lockSourceCodeProviderConfigControllerMockInformer.RUnlock()
	return calls
}

// Lister calls ListerFunc.
func (mock *SourceCodeProviderConfigControllerMock) Lister() v3.SourceCodeProviderConfigLister {
	if mock.ListerFunc == nil {
		panic("SourceCodeProviderConfigControllerMock.ListerFunc: method is nil but SourceCodeProviderConfigController.Lister was just called")
	}
	callInfo := struct {
	}{}
	lockSourceCodeProviderConfigControllerMockLister.Lock()
	mock.calls.Lister = append(mock.calls.Lister, callInfo)
	lockSourceCodeProviderConfigControllerMockLister.Unlock()
	return mock.ListerFunc()
}

// ListerCalls gets all the calls that were made to Lister.
// Check the length with:
//     len(mockedSourceCodeProviderConfigController.ListerCalls())
func (mock *SourceCodeProviderConfigControllerMock) ListerCalls() []struct {
} {
	var calls []struct {
	}
	lockSourceCodeProviderConfigControllerMockLister.RLock()
	calls = mock.calls.Lister
	lockSourceCodeProviderConfigControllerMockLister.RUnlock()
	return calls
}

var (
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedFeatureHandler   sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedFeatureLifecycle sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedHandler          sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedLifecycle        sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockAddFeatureHandler                sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockAddFeatureLifecycle              sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockAddHandler                       sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockAddLifecycle                     sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockController                       sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockCreate                           sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockDelete                           sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockDeleteCollection                 sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockDeleteNamespaced                 sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockGet                              sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockGetNamespaced                    sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockList                             sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockListNamespaced                   sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockObjectClient                     sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockUpdate                           sync.RWMutex
	lockSourceCodeProviderConfigInterfaceMockWatch                            sync.RWMutex
)

// Ensure, that SourceCodeProviderConfigInterfaceMock does implement SourceCodeProviderConfigInterface.
// If this is not the case, regenerate this file with moq.
var _ v3.SourceCodeProviderConfigInterface = &SourceCodeProviderConfigInterfaceMock{}

// SourceCodeProviderConfigInterfaceMock is a mock implementation of SourceCodeProviderConfigInterface.
//
//     func TestSomethingThatUsesSourceCodeProviderConfigInterface(t *testing.T) {
//
//         // make and configure a mocked SourceCodeProviderConfigInterface
//         mockedSourceCodeProviderConfigInterface := &SourceCodeProviderConfigInterfaceMock{
//             AddClusterScopedFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, clusterName string, sync v3.SourceCodeProviderConfigHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedFeatureHandler method")
//             },
//             AddClusterScopedFeatureLifecycleFunc: func(ctx context.Context, enabled func() bool, name string, clusterName string, lifecycle v3.SourceCodeProviderConfigLifecycle)  {
// 	               panic("mock out the AddClusterScopedFeatureLifecycle method")
//             },
//             AddClusterScopedHandlerFunc: func(ctx context.Context, name string, clusterName string, sync v3.SourceCodeProviderConfigHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedHandler method")
//             },
//             AddClusterScopedLifecycleFunc: func(ctx context.Context, name string, clusterName string, lifecycle v3.SourceCodeProviderConfigLifecycle)  {
// 	               panic("mock out the AddClusterScopedLifecycle method")
//             },
//             AddFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, sync v3.SourceCodeProviderConfigHandlerFunc)  {
// 	               panic("mock out the AddFeatureHandler method")
//             },
//             AddFeatureLifecycleFunc: func(ctx context.Context, enabled func() bool, name string, lifecycle v3.SourceCodeProviderConfigLifecycle)  {
// 	               panic("mock out the AddFeatureLifecycle method")
//             },
//             AddHandlerFunc: func(ctx context.Context, name string, sync v3.SourceCodeProviderConfigHandlerFunc)  {
// 	               panic("mock out the AddHandler method")
//             },
//             AddLifecycleFunc: func(ctx context.Context, name string, lifecycle v3.SourceCodeProviderConfigLifecycle)  {
// 	               panic("mock out the AddLifecycle method")
//             },
//             ControllerFunc: func() v3.SourceCodeProviderConfigController {
// 	               panic("mock out the Controller method")
//             },
//             CreateFunc: func(in1 *v3.SourceCodeProviderConfig) (*v3.SourceCodeProviderConfig, error) {
// 	               panic("mock out the Create method")
//             },
//             DeleteFunc: func(name string, options *v1.DeleteOptions) error {
// 	               panic("mock out the Delete method")
//             },
//             DeleteCollectionFunc: func(deleteOpts *v1.DeleteOptions, listOpts v1.ListOptions) error {
// 	               panic("mock out the DeleteCollection method")
//             },
//             DeleteNamespacedFunc: func(namespace string, name string, options *v1.DeleteOptions) error {
// 	               panic("mock out the DeleteNamespaced method")
//             },
//             GetFunc: func(name string, opts v1.GetOptions) (*v3.SourceCodeProviderConfig, error) {
// 	               panic("mock out the Get method")
//             },
//             GetNamespacedFunc: func(namespace string, name string, opts v1.GetOptions) (*v3.SourceCodeProviderConfig, error) {
// 	               panic("mock out the GetNamespaced method")
//             },
//             ListFunc: func(opts v1.ListOptions) (*v3.SourceCodeProviderConfigList, error) {
// 	               panic("mock out the List method")
//             },
//             ListNamespacedFunc: func(namespace string, opts v1.ListOptions) (*v3.SourceCodeProviderConfigList, error) {
// 	               panic("mock out the ListNamespaced method")
//             },
//             ObjectClientFunc: func() *objectclient.ObjectClient {
// 	               panic("mock out the ObjectClient method")
//             },
//             UpdateFunc: func(in1 *v3.SourceCodeProviderConfig) (*v3.SourceCodeProviderConfig, error) {
// 	               panic("mock out the Update method")
//             },
//             WatchFunc: func(opts v1.ListOptions) (watch.Interface, error) {
// 	               panic("mock out the Watch method")
//             },
//         }
//
//         // use mockedSourceCodeProviderConfigInterface in code that requires SourceCodeProviderConfigInterface
//         // and then make assertions.
//
//     }
type SourceCodeProviderConfigInterfaceMock struct {
	// AddClusterScopedFeatureHandlerFunc mocks the AddClusterScopedFeatureHandler method.
	AddClusterScopedFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, clusterName string, sync v3.SourceCodeProviderConfigHandlerFunc)

	// AddClusterScopedFeatureLifecycleFunc mocks the AddClusterScopedFeatureLifecycle method.
	AddClusterScopedFeatureLifecycleFunc func(ctx context.Context, enabled func() bool, name string, clusterName string, lifecycle v3.SourceCodeProviderConfigLifecycle)

	// AddClusterScopedHandlerFunc mocks the AddClusterScopedHandler method.
	AddClusterScopedHandlerFunc func(ctx context.Context, name string, clusterName string, sync v3.SourceCodeProviderConfigHandlerFunc)

	// AddClusterScopedLifecycleFunc mocks the AddClusterScopedLifecycle method.
	AddClusterScopedLifecycleFunc func(ctx context.Context, name string, clusterName string, lifecycle v3.SourceCodeProviderConfigLifecycle)

	// AddFeatureHandlerFunc mocks the AddFeatureHandler method.
	AddFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, sync v3.SourceCodeProviderConfigHandlerFunc)

	// AddFeatureLifecycleFunc mocks the AddFeatureLifecycle method.
	AddFeatureLifecycleFunc func(ctx context.Context, enabled func() bool, name string, lifecycle v3.SourceCodeProviderConfigLifecycle)

	// AddHandlerFunc mocks the AddHandler method.
	AddHandlerFunc func(ctx context.Context, name string, sync v3.SourceCodeProviderConfigHandlerFunc)

	// AddLifecycleFunc mocks the AddLifecycle method.
	AddLifecycleFunc func(ctx context.Context, name string, lifecycle v3.SourceCodeProviderConfigLifecycle)

	// ControllerFunc mocks the Controller method.
	ControllerFunc func() v3.SourceCodeProviderConfigController

	// CreateFunc mocks the Create method.
	CreateFunc func(in1 *v3.SourceCodeProviderConfig) (*v3.SourceCodeProviderConfig, error)

	// DeleteFunc mocks the Delete method.
	DeleteFunc func(name string, options *v1.DeleteOptions) error

	// DeleteCollectionFunc mocks the DeleteCollection method.
	DeleteCollectionFunc func(deleteOpts *v1.DeleteOptions, listOpts v1.ListOptions) error

	// DeleteNamespacedFunc mocks the DeleteNamespaced method.
	DeleteNamespacedFunc func(namespace string, name string, options *v1.DeleteOptions) error

	// GetFunc mocks the Get method.
	GetFunc func(name string, opts v1.GetOptions) (*v3.SourceCodeProviderConfig, error)

	// GetNamespacedFunc mocks the GetNamespaced method.
	GetNamespacedFunc func(namespace string, name string, opts v1.GetOptions) (*v3.SourceCodeProviderConfig, error)

	// ListFunc mocks the List method.
	ListFunc func(opts v1.ListOptions) (*v3.SourceCodeProviderConfigList, error)

	// ListNamespacedFunc mocks the ListNamespaced method.
	ListNamespacedFunc func(namespace string, opts v1.ListOptions) (*v3.SourceCodeProviderConfigList, error)

	// ObjectClientFunc mocks the ObjectClient method.
	ObjectClientFunc func() *objectclient.ObjectClient

	// UpdateFunc mocks the Update method.
	UpdateFunc func(in1 *v3.SourceCodeProviderConfig) (*v3.SourceCodeProviderConfig, error)

	// WatchFunc mocks the Watch method.
	WatchFunc func(opts v1.ListOptions) (watch.Interface, error)

	// calls tracks calls to the methods.
	calls struct {
		// AddClusterScopedFeatureHandler holds details about calls to the AddClusterScopedFeatureHandler method.
		AddClusterScopedFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Sync is the sync argument value.
			Sync v3.SourceCodeProviderConfigHandlerFunc
		}
		// AddClusterScopedFeatureLifecycle holds details about calls to the AddClusterScopedFeatureLifecycle method.
		AddClusterScopedFeatureLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v3.SourceCodeProviderConfigLifecycle
		}
		// AddClusterScopedHandler holds details about calls to the AddClusterScopedHandler method.
		AddClusterScopedHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Sync is the sync argument value.
			Sync v3.SourceCodeProviderConfigHandlerFunc
		}
		// AddClusterScopedLifecycle holds details about calls to the AddClusterScopedLifecycle method.
		AddClusterScopedLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v3.SourceCodeProviderConfigLifecycle
		}
		// AddFeatureHandler holds details about calls to the AddFeatureHandler method.
		AddFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// Sync is the sync argument value.
			Sync v3.SourceCodeProviderConfigHandlerFunc
		}
		// AddFeatureLifecycle holds details about calls to the AddFeatureLifecycle method.
		AddFeatureLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v3.SourceCodeProviderConfigLifecycle
		}
		// AddHandler holds details about calls to the AddHandler method.
		AddHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// Sync is the sync argument value.
			Sync v3.SourceCodeProviderConfigHandlerFunc
		}
		// AddLifecycle holds details about calls to the AddLifecycle method.
		AddLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v3.SourceCodeProviderConfigLifecycle
		}
		// Controller holds details about calls to the Controller method.
		Controller []struct {
		}
		// Create holds details about calls to the Create method.
		Create []struct {
			// In1 is the in1 argument value.
			In1 *v3.SourceCodeProviderConfig
		}
		// Delete holds details about calls to the Delete method.
		Delete []struct {
			// Name is the name argument value.
			Name string
			// Options is the options argument value.
			Options *v1.DeleteOptions
		}
		// DeleteCollection holds details about calls to the DeleteCollection method.
		DeleteCollection []struct {
			// DeleteOpts is the deleteOpts argument value.
			DeleteOpts *v1.DeleteOptions
			// ListOpts is the listOpts argument value.
			ListOpts v1.ListOptions
		}
		// DeleteNamespaced holds details about calls to the DeleteNamespaced method.
		DeleteNamespaced []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
			// Options is the options argument value.
			Options *v1.DeleteOptions
		}
		// Get holds details about calls to the Get method.
		Get []struct {
			// Name is the name argument value.
			Name string
			// Opts is the opts argument value.
			Opts v1.GetOptions
		}
		// GetNamespaced holds details about calls to the GetNamespaced method.
		GetNamespaced []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
			// Opts is the opts argument value.
			Opts v1.GetOptions
		}
		// List holds details about calls to the List method.
		List []struct {
			// Opts is the opts argument value.
			Opts v1.ListOptions
		}
		// ListNamespaced holds details about calls to the ListNamespaced method.
		ListNamespaced []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Opts is the opts argument value.
			Opts v1.ListOptions
		}
		// ObjectClient holds details about calls to the ObjectClient method.
		ObjectClient []struct {
		}
		// Update holds details about calls to the Update method.
		Update []struct {
			// In1 is the in1 argument value.
			In1 *v3.SourceCodeProviderConfig
		}
		// Watch holds details about calls to the Watch method.
		Watch []struct {
			// Opts is the opts argument value.
			Opts v1.ListOptions
		}
	}
}

// AddClusterScopedFeatureHandler calls AddClusterScopedFeatureHandlerFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) AddClusterScopedFeatureHandler(ctx context.Context, enabled func() bool, name string, clusterName string, sync v3.SourceCodeProviderConfigHandlerFunc) {
	if mock.AddClusterScopedFeatureHandlerFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.AddClusterScopedFeatureHandlerFunc: method is nil but SourceCodeProviderConfigInterface.AddClusterScopedFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Sync        v3.SourceCodeProviderConfigHandlerFunc
	}{
		Ctx:         ctx,
		Enabled:     enabled,
		Name:        name,
		ClusterName: clusterName,
		Sync:        sync,
	}
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedFeatureHandler.Lock()
	mock.calls.AddClusterScopedFeatureHandler = append(mock.calls.AddClusterScopedFeatureHandler, callInfo)
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedFeatureHandler.Unlock()
	mock.AddClusterScopedFeatureHandlerFunc(ctx, enabled, name, clusterName, sync)
}

// AddClusterScopedFeatureHandlerCalls gets all the calls that were made to AddClusterScopedFeatureHandler.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.AddClusterScopedFeatureHandlerCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) AddClusterScopedFeatureHandlerCalls() []struct {
	Ctx         context.Context
	Enabled     func() bool
	Name        string
	ClusterName string
	Sync        v3.SourceCodeProviderConfigHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Sync        v3.SourceCodeProviderConfigHandlerFunc
	}
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedFeatureHandler.RLock()
	calls = mock.calls.AddClusterScopedFeatureHandler
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedFeatureHandler.RUnlock()
	return calls
}

// AddClusterScopedFeatureLifecycle calls AddClusterScopedFeatureLifecycleFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) AddClusterScopedFeatureLifecycle(ctx context.Context, enabled func() bool, name string, clusterName string, lifecycle v3.SourceCodeProviderConfigLifecycle) {
	if mock.AddClusterScopedFeatureLifecycleFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.AddClusterScopedFeatureLifecycleFunc: method is nil but SourceCodeProviderConfigInterface.AddClusterScopedFeatureLifecycle was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Lifecycle   v3.SourceCodeProviderConfigLifecycle
	}{
		Ctx:         ctx,
		Enabled:     enabled,
		Name:        name,
		ClusterName: clusterName,
		Lifecycle:   lifecycle,
	}
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedFeatureLifecycle.Lock()
	mock.calls.AddClusterScopedFeatureLifecycle = append(mock.calls.AddClusterScopedFeatureLifecycle, callInfo)
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedFeatureLifecycle.Unlock()
	mock.AddClusterScopedFeatureLifecycleFunc(ctx, enabled, name, clusterName, lifecycle)
}

// AddClusterScopedFeatureLifecycleCalls gets all the calls that were made to AddClusterScopedFeatureLifecycle.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.AddClusterScopedFeatureLifecycleCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) AddClusterScopedFeatureLifecycleCalls() []struct {
	Ctx         context.Context
	Enabled     func() bool
	Name        string
	ClusterName string
	Lifecycle   v3.SourceCodeProviderConfigLifecycle
} {
	var calls []struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Lifecycle   v3.SourceCodeProviderConfigLifecycle
	}
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedFeatureLifecycle.RLock()
	calls = mock.calls.AddClusterScopedFeatureLifecycle
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedFeatureLifecycle.RUnlock()
	return calls
}

// AddClusterScopedHandler calls AddClusterScopedHandlerFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) AddClusterScopedHandler(ctx context.Context, name string, clusterName string, sync v3.SourceCodeProviderConfigHandlerFunc) {
	if mock.AddClusterScopedHandlerFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.AddClusterScopedHandlerFunc: method is nil but SourceCodeProviderConfigInterface.AddClusterScopedHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Sync        v3.SourceCodeProviderConfigHandlerFunc
	}{
		Ctx:         ctx,
		Name:        name,
		ClusterName: clusterName,
		Sync:        sync,
	}
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedHandler.Lock()
	mock.calls.AddClusterScopedHandler = append(mock.calls.AddClusterScopedHandler, callInfo)
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedHandler.Unlock()
	mock.AddClusterScopedHandlerFunc(ctx, name, clusterName, sync)
}

// AddClusterScopedHandlerCalls gets all the calls that were made to AddClusterScopedHandler.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.AddClusterScopedHandlerCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) AddClusterScopedHandlerCalls() []struct {
	Ctx         context.Context
	Name        string
	ClusterName string
	Sync        v3.SourceCodeProviderConfigHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Sync        v3.SourceCodeProviderConfigHandlerFunc
	}
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedHandler.RLock()
	calls = mock.calls.AddClusterScopedHandler
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedHandler.RUnlock()
	return calls
}

// AddClusterScopedLifecycle calls AddClusterScopedLifecycleFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) AddClusterScopedLifecycle(ctx context.Context, name string, clusterName string, lifecycle v3.SourceCodeProviderConfigLifecycle) {
	if mock.AddClusterScopedLifecycleFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.AddClusterScopedLifecycleFunc: method is nil but SourceCodeProviderConfigInterface.AddClusterScopedLifecycle was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Lifecycle   v3.SourceCodeProviderConfigLifecycle
	}{
		Ctx:         ctx,
		Name:        name,
		ClusterName: clusterName,
		Lifecycle:   lifecycle,
	}
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedLifecycle.Lock()
	mock.calls.AddClusterScopedLifecycle = append(mock.calls.AddClusterScopedLifecycle, callInfo)
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedLifecycle.Unlock()
	mock.AddClusterScopedLifecycleFunc(ctx, name, clusterName, lifecycle)
}

// AddClusterScopedLifecycleCalls gets all the calls that were made to AddClusterScopedLifecycle.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.AddClusterScopedLifecycleCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) AddClusterScopedLifecycleCalls() []struct {
	Ctx         context.Context
	Name        string
	ClusterName string
	Lifecycle   v3.SourceCodeProviderConfigLifecycle
} {
	var calls []struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Lifecycle   v3.SourceCodeProviderConfigLifecycle
	}
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedLifecycle.RLock()
	calls = mock.calls.AddClusterScopedLifecycle
	lockSourceCodeProviderConfigInterfaceMockAddClusterScopedLifecycle.RUnlock()
	return calls
}

// AddFeatureHandler calls AddFeatureHandlerFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) AddFeatureHandler(ctx context.Context, enabled func() bool, name string, sync v3.SourceCodeProviderConfigHandlerFunc) {
	if mock.AddFeatureHandlerFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.AddFeatureHandlerFunc: method is nil but SourceCodeProviderConfigInterface.AddFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v3.SourceCodeProviderConfigHandlerFunc
	}{
		Ctx:     ctx,
		Enabled: enabled,
		Name:    name,
		Sync:    sync,
	}
	lockSourceCodeProviderConfigInterfaceMockAddFeatureHandler.Lock()
	mock.calls.AddFeatureHandler = append(mock.calls.AddFeatureHandler, callInfo)
	lockSourceCodeProviderConfigInterfaceMockAddFeatureHandler.Unlock()
	mock.AddFeatureHandlerFunc(ctx, enabled, name, sync)
}

// AddFeatureHandlerCalls gets all the calls that were made to AddFeatureHandler.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.AddFeatureHandlerCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) AddFeatureHandlerCalls() []struct {
	Ctx     context.Context
	Enabled func() bool
	Name    string
	Sync    v3.SourceCodeProviderConfigHandlerFunc
} {
	var calls []struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v3.SourceCodeProviderConfigHandlerFunc
	}
	lockSourceCodeProviderConfigInterfaceMockAddFeatureHandler.RLock()
	calls = mock.calls.AddFeatureHandler
	lockSourceCodeProviderConfigInterfaceMockAddFeatureHandler.RUnlock()
	return calls
}

// AddFeatureLifecycle calls AddFeatureLifecycleFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) AddFeatureLifecycle(ctx context.Context, enabled func() bool, name string, lifecycle v3.SourceCodeProviderConfigLifecycle) {
	if mock.AddFeatureLifecycleFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.AddFeatureLifecycleFunc: method is nil but SourceCodeProviderConfigInterface.AddFeatureLifecycle was just called")
	}
	callInfo := struct {
		Ctx       context.Context
		Enabled   func() bool
		Name      string
		Lifecycle v3.SourceCodeProviderConfigLifecycle
	}{
		Ctx:       ctx,
		Enabled:   enabled,
		Name:      name,
		Lifecycle: lifecycle,
	}
	lockSourceCodeProviderConfigInterfaceMockAddFeatureLifecycle.Lock()
	mock.calls.AddFeatureLifecycle = append(mock.calls.AddFeatureLifecycle, callInfo)
	lockSourceCodeProviderConfigInterfaceMockAddFeatureLifecycle.Unlock()
	mock.AddFeatureLifecycleFunc(ctx, enabled, name, lifecycle)
}

// AddFeatureLifecycleCalls gets all the calls that were made to AddFeatureLifecycle.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.AddFeatureLifecycleCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) AddFeatureLifecycleCalls() []struct {
	Ctx       context.Context
	Enabled   func() bool
	Name      string
	Lifecycle v3.SourceCodeProviderConfigLifecycle
} {
	var calls []struct {
		Ctx       context.Context
		Enabled   func() bool
		Name      string
		Lifecycle v3.SourceCodeProviderConfigLifecycle
	}
	lockSourceCodeProviderConfigInterfaceMockAddFeatureLifecycle.RLock()
	calls = mock.calls.AddFeatureLifecycle
	lockSourceCodeProviderConfigInterfaceMockAddFeatureLifecycle.RUnlock()
	return calls
}

// AddHandler calls AddHandlerFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) AddHandler(ctx context.Context, name string, sync v3.SourceCodeProviderConfigHandlerFunc) {
	if mock.AddHandlerFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.AddHandlerFunc: method is nil but SourceCodeProviderConfigInterface.AddHandler was just called")
	}
	callInfo := struct {
		Ctx  context.Context
		Name string
		Sync v3.SourceCodeProviderConfigHandlerFunc
	}{
		Ctx:  ctx,
		Name: name,
		Sync: sync,
	}
	lockSourceCodeProviderConfigInterfaceMockAddHandler.Lock()
	mock.calls.AddHandler = append(mock.calls.AddHandler, callInfo)
	lockSourceCodeProviderConfigInterfaceMockAddHandler.Unlock()
	mock.AddHandlerFunc(ctx, name, sync)
}

// AddHandlerCalls gets all the calls that were made to AddHandler.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.AddHandlerCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) AddHandlerCalls() []struct {
	Ctx  context.Context
	Name string
	Sync v3.SourceCodeProviderConfigHandlerFunc
} {
	var calls []struct {
		Ctx  context.Context
		Name string
		Sync v3.SourceCodeProviderConfigHandlerFunc
	}
	lockSourceCodeProviderConfigInterfaceMockAddHandler.RLock()
	calls = mock.calls.AddHandler
	lockSourceCodeProviderConfigInterfaceMockAddHandler.RUnlock()
	return calls
}

// AddLifecycle calls AddLifecycleFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) AddLifecycle(ctx context.Context, name string, lifecycle v3.SourceCodeProviderConfigLifecycle) {
	if mock.AddLifecycleFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.AddLifecycleFunc: method is nil but SourceCodeProviderConfigInterface.AddLifecycle was just called")
	}
	callInfo := struct {
		Ctx       context.Context
		Name      string
		Lifecycle v3.SourceCodeProviderConfigLifecycle
	}{
		Ctx:       ctx,
		Name:      name,
		Lifecycle: lifecycle,
	}
	lockSourceCodeProviderConfigInterfaceMockAddLifecycle.Lock()
	mock.calls.AddLifecycle = append(mock.calls.AddLifecycle, callInfo)
	lockSourceCodeProviderConfigInterfaceMockAddLifecycle.Unlock()
	mock.AddLifecycleFunc(ctx, name, lifecycle)
}

// AddLifecycleCalls gets all the calls that were made to AddLifecycle.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.AddLifecycleCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) AddLifecycleCalls() []struct {
	Ctx       context.Context
	Name      string
	Lifecycle v3.SourceCodeProviderConfigLifecycle
} {
	var calls []struct {
		Ctx       context.Context
		Name      string
		Lifecycle v3.SourceCodeProviderConfigLifecycle
	}
	lockSourceCodeProviderConfigInterfaceMockAddLifecycle.RLock()
	calls = mock.calls.AddLifecycle
	lockSourceCodeProviderConfigInterfaceMockAddLifecycle.RUnlock()
	return calls
}

// Controller calls ControllerFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) Controller() v3.SourceCodeProviderConfigController {
	if mock.ControllerFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.ControllerFunc: method is nil but SourceCodeProviderConfigInterface.Controller was just called")
	}
	callInfo := struct {
	}{}
	lockSourceCodeProviderConfigInterfaceMockController.Lock()
	mock.calls.Controller = append(mock.calls.Controller, callInfo)
	lockSourceCodeProviderConfigInterfaceMockController.Unlock()
	return mock.ControllerFunc()
}

// ControllerCalls gets all the calls that were made to Controller.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.ControllerCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) ControllerCalls() []struct {
} {
	var calls []struct {
	}
	lockSourceCodeProviderConfigInterfaceMockController.RLock()
	calls = mock.calls.Controller
	lockSourceCodeProviderConfigInterfaceMockController.RUnlock()
	return calls
}

// Create calls CreateFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) Create(in1 *v3.SourceCodeProviderConfig) (*v3.SourceCodeProviderConfig, error) {
	if mock.CreateFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.CreateFunc: method is nil but SourceCodeProviderConfigInterface.Create was just called")
	}
	callInfo := struct {
		In1 *v3.SourceCodeProviderConfig
	}{
		In1: in1,
	}
	lockSourceCodeProviderConfigInterfaceMockCreate.Lock()
	mock.calls.Create = append(mock.calls.Create, callInfo)
	lockSourceCodeProviderConfigInterfaceMockCreate.Unlock()
	return mock.CreateFunc(in1)
}

// CreateCalls gets all the calls that were made to Create.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.CreateCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) CreateCalls() []struct {
	In1 *v3.SourceCodeProviderConfig
} {
	var calls []struct {
		In1 *v3.SourceCodeProviderConfig
	}
	lockSourceCodeProviderConfigInterfaceMockCreate.RLock()
	calls = mock.calls.Create
	lockSourceCodeProviderConfigInterfaceMockCreate.RUnlock()
	return calls
}

// Delete calls DeleteFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) Delete(name string, options *v1.DeleteOptions) error {
	if mock.DeleteFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.DeleteFunc: method is nil but SourceCodeProviderConfigInterface.Delete was just called")
	}
	callInfo := struct {
		Name    string
		Options *v1.DeleteOptions
	}{
		Name:    name,
		Options: options,
	}
	lockSourceCodeProviderConfigInterfaceMockDelete.Lock()
	mock.calls.Delete = append(mock.calls.Delete, callInfo)
	lockSourceCodeProviderConfigInterfaceMockDelete.Unlock()
	return mock.DeleteFunc(name, options)
}

// DeleteCalls gets all the calls that were made to Delete.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.DeleteCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) DeleteCalls() []struct {
	Name    string
	Options *v1.DeleteOptions
} {
	var calls []struct {
		Name    string
		Options *v1.DeleteOptions
	}
	lockSourceCodeProviderConfigInterfaceMockDelete.RLock()
	calls = mock.calls.Delete
	lockSourceCodeProviderConfigInterfaceMockDelete.RUnlock()
	return calls
}

// DeleteCollection calls DeleteCollectionFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) DeleteCollection(deleteOpts *v1.DeleteOptions, listOpts v1.ListOptions) error {
	if mock.DeleteCollectionFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.DeleteCollectionFunc: method is nil but SourceCodeProviderConfigInterface.DeleteCollection was just called")
	}
	callInfo := struct {
		DeleteOpts *v1.DeleteOptions
		ListOpts   v1.ListOptions
	}{
		DeleteOpts: deleteOpts,
		ListOpts:   listOpts,
	}
	lockSourceCodeProviderConfigInterfaceMockDeleteCollection.Lock()
	mock.calls.DeleteCollection = append(mock.calls.DeleteCollection, callInfo)
	lockSourceCodeProviderConfigInterfaceMockDeleteCollection.Unlock()
	return mock.DeleteCollectionFunc(deleteOpts, listOpts)
}

// DeleteCollectionCalls gets all the calls that were made to DeleteCollection.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.DeleteCollectionCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) DeleteCollectionCalls() []struct {
	DeleteOpts *v1.DeleteOptions
	ListOpts   v1.ListOptions
} {
	var calls []struct {
		DeleteOpts *v1.DeleteOptions
		ListOpts   v1.ListOptions
	}
	lockSourceCodeProviderConfigInterfaceMockDeleteCollection.RLock()
	calls = mock.calls.DeleteCollection
	lockSourceCodeProviderConfigInterfaceMockDeleteCollection.RUnlock()
	return calls
}

// DeleteNamespaced calls DeleteNamespacedFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) DeleteNamespaced(namespace string, name string, options *v1.DeleteOptions) error {
	if mock.DeleteNamespacedFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.DeleteNamespacedFunc: method is nil but SourceCodeProviderConfigInterface.DeleteNamespaced was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
		Options   *v1.DeleteOptions
	}{
		Namespace: namespace,
		Name:      name,
		Options:   options,
	}
	lockSourceCodeProviderConfigInterfaceMockDeleteNamespaced.Lock()
	mock.calls.DeleteNamespaced = append(mock.calls.DeleteNamespaced, callInfo)
	lockSourceCodeProviderConfigInterfaceMockDeleteNamespaced.Unlock()
	return mock.DeleteNamespacedFunc(namespace, name, options)
}

// DeleteNamespacedCalls gets all the calls that were made to DeleteNamespaced.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.DeleteNamespacedCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) DeleteNamespacedCalls() []struct {
	Namespace string
	Name      string
	Options   *v1.DeleteOptions
} {
	var calls []struct {
		Namespace string
		Name      string
		Options   *v1.DeleteOptions
	}
	lockSourceCodeProviderConfigInterfaceMockDeleteNamespaced.RLock()
	calls = mock.calls.DeleteNamespaced
	lockSourceCodeProviderConfigInterfaceMockDeleteNamespaced.RUnlock()
	return calls
}

// Get calls GetFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) Get(name string, opts v1.GetOptions) (*v3.SourceCodeProviderConfig, error) {
	if mock.GetFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.GetFunc: method is nil but SourceCodeProviderConfigInterface.Get was just called")
	}
	callInfo := struct {
		Name string
		Opts v1.GetOptions
	}{
		Name: name,
		Opts: opts,
	}
	lockSourceCodeProviderConfigInterfaceMockGet.Lock()
	mock.calls.Get = append(mock.calls.Get, callInfo)
	lockSourceCodeProviderConfigInterfaceMockGet.Unlock()
	return mock.GetFunc(name, opts)
}

// GetCalls gets all the calls that were made to Get.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.GetCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) GetCalls() []struct {
	Name string
	Opts v1.GetOptions
} {
	var calls []struct {
		Name string
		Opts v1.GetOptions
	}
	lockSourceCodeProviderConfigInterfaceMockGet.RLock()
	calls = mock.calls.Get
	lockSourceCodeProviderConfigInterfaceMockGet.RUnlock()
	return calls
}

// GetNamespaced calls GetNamespacedFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) GetNamespaced(namespace string, name string, opts v1.GetOptions) (*v3.SourceCodeProviderConfig, error) {
	if mock.GetNamespacedFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.GetNamespacedFunc: method is nil but SourceCodeProviderConfigInterface.GetNamespaced was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
		Opts      v1.GetOptions
	}{
		Namespace: namespace,
		Name:      name,
		Opts:      opts,
	}
	lockSourceCodeProviderConfigInterfaceMockGetNamespaced.Lock()
	mock.calls.GetNamespaced = append(mock.calls.GetNamespaced, callInfo)
	lockSourceCodeProviderConfigInterfaceMockGetNamespaced.Unlock()
	return mock.GetNamespacedFunc(namespace, name, opts)
}

// GetNamespacedCalls gets all the calls that were made to GetNamespaced.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.GetNamespacedCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) GetNamespacedCalls() []struct {
	Namespace string
	Name      string
	Opts      v1.GetOptions
} {
	var calls []struct {
		Namespace string
		Name      string
		Opts      v1.GetOptions
	}
	lockSourceCodeProviderConfigInterfaceMockGetNamespaced.RLock()
	calls = mock.calls.GetNamespaced
	lockSourceCodeProviderConfigInterfaceMockGetNamespaced.RUnlock()
	return calls
}

// List calls ListFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) List(opts v1.ListOptions) (*v3.SourceCodeProviderConfigList, error) {
	if mock.ListFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.ListFunc: method is nil but SourceCodeProviderConfigInterface.List was just called")
	}
	callInfo := struct {
		Opts v1.ListOptions
	}{
		Opts: opts,
	}
	lockSourceCodeProviderConfigInterfaceMockList.Lock()
	mock.calls.List = append(mock.calls.List, callInfo)
	lockSourceCodeProviderConfigInterfaceMockList.Unlock()
	return mock.ListFunc(opts)
}

// ListCalls gets all the calls that were made to List.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.ListCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) ListCalls() []struct {
	Opts v1.ListOptions
} {
	var calls []struct {
		Opts v1.ListOptions
	}
	lockSourceCodeProviderConfigInterfaceMockList.RLock()
	calls = mock.calls.List
	lockSourceCodeProviderConfigInterfaceMockList.RUnlock()
	return calls
}

// ListNamespaced calls ListNamespacedFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) ListNamespaced(namespace string, opts v1.ListOptions) (*v3.SourceCodeProviderConfigList, error) {
	if mock.ListNamespacedFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.ListNamespacedFunc: method is nil but SourceCodeProviderConfigInterface.ListNamespaced was just called")
	}
	callInfo := struct {
		Namespace string
		Opts      v1.ListOptions
	}{
		Namespace: namespace,
		Opts:      opts,
	}
	lockSourceCodeProviderConfigInterfaceMockListNamespaced.Lock()
	mock.calls.ListNamespaced = append(mock.calls.ListNamespaced, callInfo)
	lockSourceCodeProviderConfigInterfaceMockListNamespaced.Unlock()
	return mock.ListNamespacedFunc(namespace, opts)
}

// ListNamespacedCalls gets all the calls that were made to ListNamespaced.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.ListNamespacedCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) ListNamespacedCalls() []struct {
	Namespace string
	Opts      v1.ListOptions
} {
	var calls []struct {
		Namespace string
		Opts      v1.ListOptions
	}
	lockSourceCodeProviderConfigInterfaceMockListNamespaced.RLock()
	calls = mock.calls.ListNamespaced
	lockSourceCodeProviderConfigInterfaceMockListNamespaced.RUnlock()
	return calls
}

// ObjectClient calls ObjectClientFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) ObjectClient() *objectclient.ObjectClient {
	if mock.ObjectClientFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.ObjectClientFunc: method is nil but SourceCodeProviderConfigInterface.ObjectClient was just called")
	}
	callInfo := struct {
	}{}
	lockSourceCodeProviderConfigInterfaceMockObjectClient.Lock()
	mock.calls.ObjectClient = append(mock.calls.ObjectClient, callInfo)
	lockSourceCodeProviderConfigInterfaceMockObjectClient.Unlock()
	return mock.ObjectClientFunc()
}

// ObjectClientCalls gets all the calls that were made to ObjectClient.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.ObjectClientCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) ObjectClientCalls() []struct {
} {
	var calls []struct {
	}
	lockSourceCodeProviderConfigInterfaceMockObjectClient.RLock()
	calls = mock.calls.ObjectClient
	lockSourceCodeProviderConfigInterfaceMockObjectClient.RUnlock()
	return calls
}

// Update calls UpdateFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) Update(in1 *v3.SourceCodeProviderConfig) (*v3.SourceCodeProviderConfig, error) {
	if mock.UpdateFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.UpdateFunc: method is nil but SourceCodeProviderConfigInterface.Update was just called")
	}
	callInfo := struct {
		In1 *v3.SourceCodeProviderConfig
	}{
		In1: in1,
	}
	lockSourceCodeProviderConfigInterfaceMockUpdate.Lock()
	mock.calls.Update = append(mock.calls.Update, callInfo)
	lockSourceCodeProviderConfigInterfaceMockUpdate.Unlock()
	return mock.UpdateFunc(in1)
}

// UpdateCalls gets all the calls that were made to Update.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.UpdateCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) UpdateCalls() []struct {
	In1 *v3.SourceCodeProviderConfig
} {
	var calls []struct {
		In1 *v3.SourceCodeProviderConfig
	}
	lockSourceCodeProviderConfigInterfaceMockUpdate.RLock()
	calls = mock.calls.Update
	lockSourceCodeProviderConfigInterfaceMockUpdate.RUnlock()
	return calls
}

// Watch calls WatchFunc.
func (mock *SourceCodeProviderConfigInterfaceMock) Watch(opts v1.ListOptions) (watch.Interface, error) {
	if mock.WatchFunc == nil {
		panic("SourceCodeProviderConfigInterfaceMock.WatchFunc: method is nil but SourceCodeProviderConfigInterface.Watch was just called")
	}
	callInfo := struct {
		Opts v1.ListOptions
	}{
		Opts: opts,
	}
	lockSourceCodeProviderConfigInterfaceMockWatch.Lock()
	mock.calls.Watch = append(mock.calls.Watch, callInfo)
	lockSourceCodeProviderConfigInterfaceMockWatch.Unlock()
	return mock.WatchFunc(opts)
}

// WatchCalls gets all the calls that were made to Watch.
// Check the length with:
//     len(mockedSourceCodeProviderConfigInterface.WatchCalls())
func (mock *SourceCodeProviderConfigInterfaceMock) WatchCalls() []struct {
	Opts v1.ListOptions
} {
	var calls []struct {
		Opts v1.ListOptions
	}
	lockSourceCodeProviderConfigInterfaceMockWatch.RLock()
	calls = mock.calls.Watch
	lockSourceCodeProviderConfigInterfaceMockWatch.RUnlock()
	return calls
}

var (
	lockSourceCodeProviderConfigsGetterMockSourceCodeProviderConfigs sync.RWMutex
)

// Ensure, that SourceCodeProviderConfigsGetterMock does implement SourceCodeProviderConfigsGetter.
// If this is not the case, regenerate this file with moq.
var _ v3.SourceCodeProviderConfigsGetter = &SourceCodeProviderConfigsGetterMock{}

// SourceCodeProviderConfigsGetterMock is a mock implementation of SourceCodeProviderConfigsGetter.
//
//     func TestSomethingThatUsesSourceCodeProviderConfigsGetter(t *testing.T) {
//
//         // make and configure a mocked SourceCodeProviderConfigsGetter
//         mockedSourceCodeProviderConfigsGetter := &SourceCodeProviderConfigsGetterMock{
//             SourceCodeProviderConfigsFunc: func(namespace string) v3.SourceCodeProviderConfigInterface {
// 	               panic("mock out the SourceCodeProviderConfigs method")
//             },
//         }
//
//         // use mockedSourceCodeProviderConfigsGetter in code that requires SourceCodeProviderConfigsGetter
//         // and then make assertions.
//
//     }
type SourceCodeProviderConfigsGetterMock struct {
	// SourceCodeProviderConfigsFunc mocks the SourceCodeProviderConfigs method.
	SourceCodeProviderConfigsFunc func(namespace string) v3.SourceCodeProviderConfigInterface

	// calls tracks calls to the methods.
	calls struct {
		// SourceCodeProviderConfigs holds details about calls to the SourceCodeProviderConfigs method.
		SourceCodeProviderConfigs []struct {
			// Namespace is the namespace argument value.
			Namespace string
		}
	}
}

// SourceCodeProviderConfigs calls SourceCodeProviderConfigsFunc.
func (mock *SourceCodeProviderConfigsGetterMock) SourceCodeProviderConfigs(namespace string) v3.SourceCodeProviderConfigInterface {
	if mock.SourceCodeProviderConfigsFunc == nil {
		panic("SourceCodeProviderConfigsGetterMock.SourceCodeProviderConfigsFunc: method is nil but SourceCodeProviderConfigsGetter.SourceCodeProviderConfigs was just called")
	}
	callInfo := struct {
		Namespace string
	}{
		Namespace: namespace,
	}
	lockSourceCodeProviderConfigsGetterMockSourceCodeProviderConfigs.Lock()
	mock.calls.SourceCodeProviderConfigs = append(mock.calls.SourceCodeProviderConfigs, callInfo)
	lockSourceCodeProviderConfigsGetterMockSourceCodeProviderConfigs.Unlock()
	return mock.SourceCodeProviderConfigsFunc(namespace)
}

// SourceCodeProviderConfigsCalls gets all the calls that were made to SourceCodeProviderConfigs.
// Check the length with:
//     len(mockedSourceCodeProviderConfigsGetter.SourceCodeProviderConfigsCalls())
func (mock *SourceCodeProviderConfigsGetterMock) SourceCodeProviderConfigsCalls() []struct {
	Namespace string
} {
	var calls []struct {
		Namespace string
	}
	lockSourceCodeProviderConfigsGetterMockSourceCodeProviderConfigs.RLock()
	calls = mock.calls.SourceCodeProviderConfigs
	lockSourceCodeProviderConfigsGetterMockSourceCodeProviderConfigs.RUnlock()
	return calls
}
